/*
 *	configuration  update ɂ̒gQƂĂ
 *	application c rule-tree ̓rĂ邱Ƃ͂蓾B
 *	͉ƂȂƂȂƎvB(܂胁bZ[W[v̂ǂ̈ʒuŁA)
 */

#if !defined (UNITTEST)
#include "globals.h"
#else
#include "StdAfx.h"
#endif
#include "RuleTreeNode.h"
#include "keymap.h"
#include "jstring.h"
#include "ImeConfig.h"

/*========================================================================
 *	Registry-related definitions
 */
/*	generic configs */
#define	REGPATH_GENERIC						REGPATH_SKKIME L"\\Generic"
#define	REGINFO_KANAMODEWHENOPEN			L"KanaModeWhenOpen"
#define	REGINFO_ECHO						L"Echo"
#define	REGINFO_EGGLIKENEWLINE				L"EggLikeNewline"
#define	REGINFO_NEWLINEKAKUTEIALL			L"NewlineKakuteiAll"
#define	REGINFO_AUTOINSERTPAREN				L"AutoInsertParen"
#define	REGINFO_COMPOSITIONAUTOSHIFT		L"CompTextAutoShift"
#define	REGINFO_DELETEIMPLIESKAKUTEI		L"DeleteImpliesKakutei"
#define	REGINFO_DATEAD						L"DateAd"
#define	REGINFO_NUMBERSTYLE					L"NumberStyle"
#define	REGINFO_BRACKETPARENS				L"CustomBracketParens"
#define	REGINFO_KUTOUTENTYPE				L"KutoutenType"
#define	REGINFO_KUTOUTENS					L"CustomKutoutens"
#define	REGINFO_KAKUTEIEARLY				L"KakuteiEarly"
#define	REGINFO_OKURICHARALISTTYPE			L"OkuriCharAlistType"
#define	REGINFO_OKURICHARALIST				L"OkuriCharAlist"
#define	REGINFO_TICK						L"Tick"

/* key related */
#define	REGPATH_KEYMAP						REGPATH_SKKIME L"\\Generic"
#define	REGINFO_MAJORMODEMAP				L"MajorModeMap"
#define	REGINFO_JMODEMAP					L"JModeMap"
#define	REGINFO_LATINMODEMAP				L"LatinModeMap"
#define	REGINFO_ZENKAKUMODEMAP				L"Jisx0208LatinModeMap"
#define	REGINFO_ABBREVMODEMAP				L"AbbrevModeMap"
#define	REGINFO_MAJORMODEMAP_EX				L"MajorModeMapEx"
#define	REGINFO_JMODEMAP_EX					L"JModeMapEx"
#define	REGINFO_LATINMODEMAP_EX				L"LatinModeMapEx"
#define	REGINFO_ZENKAKUMODEMAP_EX			L"Jisx0208LatinModeMapEx"
#define	REGINFO_ABBREVMODEMAP_EX			L"AbbrevModeMapEx"
#define	REGINFO_KEYMAP_TYPE					L"KeymapType"
#define	REGINFO_STARTHENKANKEY_TYPE			L"StartHenkanKeyType"
#define	REGINFO_STARTHENKANKEY				L"StartHenkanKey"
#define	REGINFO_COMPLETIONRELATEDKEY_TYPE	L"CompletionRelatedKeyType"
#define	REGINFO_TRYCOMPLETIONKEY			L"TryCompletionKey"
#define	REGINFO_PREVIOUSCOMPLETIONKEY		L"PreviousCompletionKey"
#define	REGINFO_NEXTCOMPLETIONKEY			L"NextCompletionKey"
#define	REGINFO_SETHENKANPOINTSUBRKEY_TYPE	L"SetHenkanPointSubrKeyType"
#define	REGINFO_SETHENKANPOINTSUBRKEY		L"SetHenkanPointSubrKey"
#define	REGINFO_SPECIALMIDASHICHAR_TYPE		L"SpecialMidashiCharType"
#define	REGINFO_SPECIALMIDASHICHAR			L"SpecialMidashiChar"

#define	REGPATH_ROMAKANARULE				REGPATH_SKKIME L"\\Generic"
#define	REGINFO_ROMAKANARULE_TYPE			L"RomaKana-RuleType"
#define	REGINFO_ROMAKANARULE				L"RomaKanaRule"
#define	REGPATH_ENABLEOHHENKAN				REGPATH_ROMAKANARULE
#define	REGINFO_ENABLEOHHENKAN				L"EnableOHHenkan"

#define	ENABLE_OHHENKAN_DEFAULT_VALUE		TRUE

#define	REGPATH_ZENKAKUVECTOR				REGPATH_SKKIME L"\\Generic"
#define	REGINFO_ZENKAKUVECTOR_TYPE			L"ZenkakuVectorType"
#define	REGINFO_ZENKAKUVECTOR				L"ZenkakuVector"

/* conversion config */
#define	REGPATH_CONVERSION					REGPATH_SKKIME L"\\Conversion"
#define	REGINFO_CANDLISTKEYASSIGN			L"CandidateListKeyAssign"
#define	REGINFO_SHOWCANDIDATEKEYS			L"ShowCandidateKeys"
#define	REGINFO_INPUTCODEMENU1KEYS			L"InputCodeMenu1Keys"
#define	REGINFO_INPUTCODEMENU2KEYS			L"InputCodeMenu2Keys"
#define	REGINFO_SHOWCANDIDATELISTCOUNT		L"ShowCandidateListCount"
#define	REGINFO_HENKANOKURISTRICTLY			L"HenkanOkuriStrictly"
#define	REGINFO_PROCESSOKURIEARLY			L"ProcessOkuriEarly"
#define	REGINFO_HENKANSTRICTOKURIPRECEDENCE	L"HenkanStrictOkuriPrecedence"
#define	REGINFO_AUTOOKURIPROCESS			L"AutoOkuriProcess"
#define	REGINFO_AUTOSTARTHENKAN				L"AutoStartHenkan"
#define	REGINFO_AUTOSTARTHENKANKEYWORD		L"AutoStartHenkanKeyword"
#define	REGINFO_DELETEOKURIWHENQUIT			L"DeleteOkuriWhenQuit"
#define	REGINFO_SHOWANNOTATIONTYPE			L"ShowAnnotationType"
#define	REGINFO_NUMERICCONVERSION			L"NumericConversion"
#define	REGINFO_NUMERICFLOAT				L"NumericFloat"

/* colorface */
#define	REGPATH_COLORFACE					REGPATH_SKKIME L"\\ColorFace"
#define	REGSUBKEY_COLORFACE					L"style"

/*========================================================================
 *	definitions
 */
#define	MAX_KEYBINDS					SIZE_IMEDOC_KEYMAP
#define	MAX_LENGTH_INPUTVECTOR			128
#define	MAX_SPECIALKEYS					64

enum {
	KEYBINDTP_DEFAULT		= 0,
	KEYBINDTP_USERDEFINED,
} ;

enum {
	REGKEYTYPE_UNKNOWN	= -1,
	REGKEYTYPE_BOOL		= 0,
	REGKEYTYPE_INT,
} ;

enum {
	KUTOUTEN_TYPE_JP	= 0,
	KUTOUTEN_TYPE_EN,
	KUTOUTEN_TYPE_CUSTOM,
} ;

enum {
	BRACKETPARENTP_DEFAULT	= 0,
	BRACKETPARENTP_USERDEFINED,
} ;

enum {
	OKURICHARTP_DEFAULT	= 0,
	OKURICHARTP_USERDEFINED,
} ;

#define	BUFSIZE_STRPAIR					32

#define	MAX_NUMKUTOUTENS				32
#define	MAX_NUMBRACKETPARENS			32
#define	MAX_NUMOKURICHARPAIR			32

/* for menu-keys (show-candidates-list-keys, input-by-code-or-menu1/2-keys */
#define	MAX_NUMMENUKEYS					256

enum {
	CANDLIST_KEYASSIGN_DEFAULT			= 0,
	CANDLIST_KEYASSIGN_01234567890,
	CANDLIST_KEYASSIGN_USERDEFINED		= 65535,
} ;

/* for colorface */
#define	MAX_NUMCOLORFACES	2

/*========================================================================
 *	structures
 */
struct TStringPair {
	WCHAR	m_bufLeft  [BUFSIZE_STRPAIR] ;
	WCHAR	m_bufRight [BUFSIZE_STRPAIR] ;
} ;

struct MYCOLORDEF {
	LPCWSTR		m_strText ;
	int			m_nType ;
} ;

/*========================================================================
 *	prototypes
 */
static	BOOL	imeConfig_bLoadZenkakuVector		(void) ;
static	void	imeConfig_vClearZenkakuVector		(void) ;
static	BOOL	imeConfig_bLoadRomaKanaRuleList		(void) ;
static	void	imeConfig_vClearRomaKanaRuleList	(void) ;
static	BOOL	imeConfig_bLoadKeymap				(void) ;
static	BOOL	imeConfig_bLoadGenericSetting		(void) ;
static	BOOL	imeConfig_bLoadConversionSetting	(void) ;
static	BOOL	imeConfig_bLoadColorfaceSetting		(void) ;
static	BOOL	imeConfig_bParseBSEncodedString		(LPCWSTR*, LPWSTR, int, BOOL*) ;
static	int		imeConfig_iDecodeStringPairList		(LPCWSTR, struct TStringPair*, int) ;
static	void	imeConfig_vClearKeymaps				(void) ;
static	void	imeConfig_vClearKeymap				(struct CImeKeymap*) ;
static	BOOL	imeConfig_bDefineKey				(struct CImeKeymap*, int, unsigned int, BOOL, int) ;

/*========================================================================
 *	global variables (default settings)
 */
static	LPCWSTR	_rstrDefaultJisx0208LatinVector [128]	= {
	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,
	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,
	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,
	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,
	L"@",	L"I",	L"h",	L"",	L"",	L"",	L"",	L"f",
	L"i",	L"j",	L"",	L"{",	L"C",	L"|",	L"D",	L"^",
	L"O",	L"P",	L"Q",	L"R",	L"S",	L"T",	L"U",	L"V",
	L"W",	L"X",	L"F",	L"G",	L"",	L"",	L"",	L"H",
	L"",	L"`",	L"a",	L"b",	L"c",	L"d",	L"e",	L"f",
	L"g",	L"h",	L"i",	L"j",	L"k",	L"l",	L"m",	L"n",
	L"o",	L"p",	L"q",	L"r",	L"s",	L"t",	L"u",	L"v",
	L"w",	L"x",	L"y",	L"m",	L"_",	L"n",	L"O",	L"Q",
	L"e",	L"",	L"",	L"",	L"",	L"",	L"",	L"",
	L"",	L"",	L"",	L"",	L"",	L"",	L"",	L"",
	L"",	L"",	L"",	L"",	L"",	L"",	L"",	L"",
	L"",	L"",	L"",	L"o",	L"b",	L"p",	L"`",	NULL,
} ;

/*========================================================================
 *	global variables (current settings)
 */
/* key related config */
static	int			_siRomaKanaRuleListType ;
static	int			_siKeybindType ;
static	int			_siStartHenkanKeyType ;
static	int			_siCompletionRelatedKeyType ;
static	int			_siSetHenkanPointSubrKeyType ;
static	int			_siSpecialMidashiCharKeyType ;

static	CSkkRuleTreeNode*		_pSkkRuleTree						= NULL ;
static	LPWSTR					_rstrJisx0208LatinVector	[128]	= { NULL } ;
static	struct CImeKeymap		_sMajorModeMap ;
static	struct CImeKeymap		_sSkkJModeMap ;
static	struct CImeKeymap		_sSkkLatinModeMap ;
static	struct CImeKeymap		_sSkkJisx0208LatinModeMap ;
static	struct CImeKeymap		_sSkkAbbrevModeMap ;
static	struct CImeKeymap		_sMinibufferMinorModeMap ;
static	BOOL					_bOHHenkan ;
static	CSkkRuleTreeNodeOutput*	_pOhOutput						= NULL ;


/* skk-insert œȓL[̐ݒB(ǂ rule ɏȂ񂾂낤H) */
static	int			_siNumStartHenkanKeys ;
static	BYTE		_srbyStartHenkanKeys			[MAX_SPECIALKEYS] ;
static	int			_siNumTryCompletionKeys ;
static	BYTE		_srbyTryCompletionKeys			[MAX_SPECIALKEYS] ;
static	int			_siNumPreviousCompletionKeys ;
static	BYTE		_srbyPreviousCompletionKeys		[MAX_SPECIALKEYS] ;
static	int			_siNumNextCompletionKeys ;
static	BYTE		_srbyNextCompletionKeys			[MAX_SPECIALKEYS] ;
static	int			_siNumSetHenkanPointSubrKeys ;
static	BYTE		_srbySetHenkanPointSubrKeys		[MAX_SPECIALKEYS] ;
static	int			_siNumSpecialMidashiCharKeys ;
static	BYTE		_srbySpecialMidashiCharKeys		[MAX_SPECIALKEYS] ;

static	BOOL		_bEggLikeNewline		= FALSE ;
static	BOOL		_bNewlineKakuteiAll		= TRUE ;

/* generic config */
static	BOOL		_bKanaModeWhenOpen		= TRUE ;
static	BOOL		_bEcho					= TRUE ;
static	BOOL		_bAutoInsertParen		= TRUE ;
static	BOOL		_bCompositionAutoShift	= TRUE ;
static	BOOL		_bDeleteImpliesKakutei	= TRUE ;
static	BOOL		_bKakuteiEarly			= FALSE ;

/* date & number style */
static	int			_bDateAd				= FALSE ;
static	int			_iNumberStyle			= 0 ;

/* kutouten & bracket settins */
static	int						_iKutoutenType			= KUTOUTEN_TYPE_JP ;
static	int						_iNumKutouten			= 0 ;
static	int						_iNumBracketParen		= 0 ;
static	int						_iNumOkuriCharAlist		= 0 ;
static	struct TStringPair		_srKutouten			[MAX_NUMKUTOUTENS] ;
static	int						_iBracketParenType		= BRACKETPARENTP_DEFAULT ;
static	struct TStringPair		_srBracketParen		[MAX_NUMBRACKETPARENS] ;
static	int						_iOkuriCharAlistType	= OKURICHARTP_DEFAULT ;
static	struct TStringPair		_srOkuriCharAlist	[MAX_NUMOKURICHARPAIR] ;

/* conversion settings */
static	int			_snCandListKeyAssign			= CANDLIST_KEYASSIGN_DEFAULT ;

static	int			_snNumShowCandidateKeys ;
static	int			_snNumInputCodeMenu1Keys ;
static	int			_snNumInputCodeMenu2Keys ;
static	WCHAR		_srwchShowCandidateKeys  [MAX_NUMMENUKEYS]	= { 0 } ;
static	WCHAR		_srwchInputCodeMenu1Keys [MAX_NUMMENUKEYS]	= { 0 } ;
static	WCHAR		_srwchInputCodeMenu2Keys [MAX_NUMMENUKEYS]	= { 0 } ;
static	int			_snShowCandListCount			= SHOWCANDLIST_COUNT_ZERO+3 ;

static	BOOL		_sbHenkanOkuriStrictly			= FALSE ;
static	BOOL		_sbProcessOkuriEarly			= FALSE ;
static	BOOL		_sbHenkanStrictOkuriPrecedence	= FALSE ;
static	BOOL		_sbAutoOkuriProcess				= FALSE ;
static	BOOL		_sbAutoStartHenkan				= TRUE ;
static	BOOL		_sbDeleteOkuriWhenQuit			= FALSE ;

static	BOOL		_sbNumericConversion			= TRUE ;
static	BOOL		_sbNumericFloat					= FALSE ;

static	int			_snShowAnnotationType			= SHOW_NO_ANNOTATION ;

static	int			_siNumAutoStartHenkanKeywords		= 0 ;
static	WCHAR		_srAutoStartHenkanKeywords [1024]	= { L'\0' } ;

/* colorface settings */
static	 MYCOLORFACESET	_srImeColorFaces [MAX_NUMCOLORFACES] ;

/*	Dialog ɂȂ(ݒ荀ڂYĂ㕨)
 *	completion  1property sheet page ĂǂƎvB
 */
static	BOOL	_bAllowsSpacesNewlinesAndTabs	= FALSE ;
/* ڃR[h͂ default kanji-code charset */
static	int		_iKanjiCodeCharset				= KCODE_CHARSET_JAPANESE_JISX0208 ;
static	BOOL	_bCompCirculate					= FALSE ;

/*	ɖ́B
 *	ImeDoc_bSkkTryCompletionCharp (const struct CImeDoc* pDoc, int nCH)
 *	BOOL	ImeConfig_bSkkStartHenkanCharp (int						nCH)
 *	̂B
 */

/*	ݒ sync ɎgB
 */
static	BOOL	_bHaveSyncTick	= FALSE ;
static	DWORD	_dwSyncTick		= 0 ;

/*========================================================================
 *	public functions
 */
void
ImeConfig_vLoad (void)
{
	HKEY	hSubKey ;
	DWORD	dwTick		= 0 ;
	BOOL	bHaveTick	= FALSE ;

	if (RegOpenKeyExW (HKEY_CURRENT_USER, REGPATH_GENERIC, 0, KEY_READ, &hSubKey) == ERROR_SUCCESS) {
		DWORD	dwType, cbData ;
		LONG	lResult ;

		cbData	= sizeof (DWORD) ;
		lResult	= RegQueryValueExW (hSubKey, REGINFO_TICK, NULL, &dwType, (BYTE*)&dwTick, &cbData) ;
		if (lResult == ERROR_SUCCESS && dwType == REG_DWORD) {
			bHaveTick	= TRUE ;
		}
		RegCloseKey (hSubKey) ;
	}
	imeConfig_bLoadZenkakuVector () ;
	imeConfig_bLoadRomaKanaRuleList () ;
	imeConfig_bLoadKeymap () ;
	imeConfig_bLoadGenericSetting () ;
	imeConfig_bLoadConversionSetting () ;
	imeConfig_bLoadColorfaceSetting () ;

	_bHaveSyncTick	= bHaveTick ;
	_dwSyncTick		= dwTick ;
	return ;
}

void
ImeConfig_vUnload (void)
{
	imeConfig_vClearZenkakuVector () ;
	imeConfig_vClearRomaKanaRuleList () ;
	imeConfig_vClearKeymaps () ;
	_bHaveSyncTick	= FALSE ;
	_dwSyncTick		= 0 ;
	return ;
}

void
ImeConfig_vUpdate (void)
{
	HKEY	hSubKey ;
	DWORD	cbData, dwType, dwTick ;
	BOOL	bUpdate ;
	LONG	lResult ;

	if (RegOpenKeyExW (HKEY_CURRENT_USER, REGPATH_GENERIC, 0, KEY_READ, &hSubKey) != ERROR_SUCCESS) 
		return ;

	bUpdate	= FALSE ;
	cbData	= sizeof (DWORD) ;
	lResult	= RegQueryValueExW (hSubKey, REGINFO_TICK, NULL, &dwType, (BYTE*)&dwTick, &cbData) ;
	if (lResult == ERROR_SUCCESS && dwType == REG_DWORD) {
		bUpdate	= ! _bHaveSyncTick || (_dwSyncTick != dwTick) ;
	}
	RegCloseKey (hSubKey) ;
	if (! bUpdate)
		return ;

	ImeConfig_vUnload () ;
	ImeConfig_vLoad () ;
	_bHaveSyncTick	= TRUE ;
	_dwSyncTick		= dwTick ;
	return ;
}

/*
 */
BOOL
ImeConfig_bKanaModeWhenOpenp (void)
{
	return	_bKanaModeWhenOpen ;
}

CSkkRuleTreeNode*
ImeConfig_pGetSkkRuleTree (void)
{
	return	_pSkkRuleTree ;
}

BOOL
ImeConfig_bSkkKakuteiEarlyp (void) 
{
	return	_bKakuteiEarly ;
}

BOOL
ImeConfig_bSkkProcessOkuriEarlyp (void) 
{
	return	_sbProcessOkuriEarly ;
}

BOOL
ImeConfig_bSkkEchop (void)
{
	return	_bEcho ;
}

BOOL
ImeConfig_bSkkTryCompletionCharp (int nCH)
{
	if (_siCompletionRelatedKeyType == KEYBINDTP_DEFAULT) {
		return	(nCH == L'\t')? TRUE : FALSE ;
	} else {
		return	(memchr (_srbyTryCompletionKeys, nCH, _siNumTryCompletionKeys) != NULL)? TRUE : FALSE ;
	}
}

BOOL
ImeConfig_bSkkPreviousCompletionCharp (int nCH)
{
	if (_siCompletionRelatedKeyType == KEYBINDTP_DEFAULT) {
		return	(nCH == L'.')? TRUE : FALSE ;
	} else {
		return	(memchr (_srbyPreviousCompletionKeys, nCH, _siNumPreviousCompletionKeys) != NULL)? TRUE : FALSE ;
	}
}

BOOL
ImeConfig_bSkkNextCompletionCharp (int nCH)
{
	if (_siCompletionRelatedKeyType == KEYBINDTP_DEFAULT) {
		return	(nCH == L',')? TRUE : FALSE ;
	} else {
		return	(memchr (_srbyNextCompletionKeys, nCH, _siNumNextCompletionKeys) != NULL)? TRUE : FALSE ;
	}
}

BOOL
ImeConfig_bSkkAutoStartHenkanp (void)
{
	return	_sbAutoStartHenkan ;	//FALSE
}

BOOL
ImeConfig_bSkkAutoStartHenkanKeywordp (
	LPCWSTR						pwString,
	int							nStringLength)
{
	/*	ϊX^[gL[[hƂ̂̂YĂcB̓JX^}CYڂB
	static	LPCWSTR		_rstrSkkAutoStartHenkanKeywords []	= {
		L"", L"A", L"B", L"D", L"C", L"H", L"v",  L"I", L"G", L"F", L")", L";", L":",
		L"j", L"h", L"z", L"x", L"t", L"r", L"p",  L"n", L"l", L"}",  L"]", L"?", L".",
		L",",  L"!",
	} ;
	 */
	LPCWSTR		pKeywords ;
	int			i ;

	if (pwString == NULL || nStringLength <= 0)
		return	FALSE ;

	pKeywords	= _srAutoStartHenkanKeywords ;
	for (i = 0 ; i < _siNumAutoStartHenkanKeywords && *pKeywords != L'\0' ; i ++) {
		if (! wcsncmp (pKeywords, pwString, nStringLength) && pKeywords [nStringLength] == L'\0')
			return	TRUE ;
		pKeywords	+= lstrlenW (pKeywords) + 1 ;
	}
	return	FALSE ;
}

BOOL
ImeConfig_bSkkSpecialMidashiCharp (int nCH)
{
	if (_siSpecialMidashiCharKeyType == KEYBINDTP_DEFAULT) {
		return	(nCH == L'?' || nCH == L'>' || nCH == L'<')? TRUE : FALSE ;
	} else {
		int		i ;
		for (i = 0 ; i < _siNumSpecialMidashiCharKeys && i < MYARRAYSIZE (_srbySpecialMidashiCharKeys) ; i ++) {
			if (_srbySpecialMidashiCharKeys [i] == nCH)
				return	TRUE ;
		}
		return	FALSE ;
	}
}

BOOL
ImeConfig_bSkkSetHenkanPointKeyp (int nCH) 
{
	if (_siSetHenkanPointSubrKeyType == KEYBINDTP_DEFAULT) {
		/* (?A ?B ?C ?D ?E ?F ?G ?H ?I ?J ?K ?M ?N ?O ?P ?R ?S ?T ?U ?V ?W ?Y ?Z) */
		return	(L'A' <= nCH && nCH <= L'Z' && nCH != L'L' && nCH != L'Q' && nCH != L'X')? TRUE : FALSE ;
	} else {
		int	i ;
		for (i = 0 ; i < _siNumSetHenkanPointSubrKeys && i < MYARRAYSIZE (_srbySetHenkanPointSubrKeys) ; i ++) {
			if (_srbySetHenkanPointSubrKeys [i] == nCH)
				return	TRUE ;
		}
		return	FALSE ;
	}
}

BOOL
ImeConfig_bSkkStartHenkanCharp (
	int						nCH)
{
	/* [ށA͂ǂׂB͂ j-mode-map Ń`FbNB
	 *	... space  skk-insert Ȃ̂B skk-insert  start-henkan ƌ߂ɂ̂c
	 *	͂܂ȁBkeyfunc | skk-insert ǁcɂȂƂ߂B
	 *	̓L[̒ǉ̂ƂŐݒ肳邵ȂȁB
	 */
	if (_siStartHenkanKeyType == KEYBINDTP_DEFAULT) {
		return	(nCH == L' ')? TRUE : FALSE ;
	} else {
		return	(memchr (_srbyStartHenkanKeys, nCH, _siNumStartHenkanKeys) != NULL)? TRUE : FALSE ;
	}
}

int
ImeConfig_iSkkARefSkkKanaRomVector (
	int						nCH, 
	LPWSTR					pOkuri,
	int						nOkuri)
{
	/*	̕\AJX^}CYKv͂̂낤H ۑƂĐSɗ߂ĂƁB
	 */
	static const struct {
		int				nKana ;
		LPCWSTR			wstrRom ;
	}	_rSkkKanaRomVector []	= {
		{ L'', L"x" },	{ L'', L"a" },	{ L'', L"x" },	{ L'', L"i" },
		{ L'', L"x" },	{ L'', L"u" },	{ L'', L"x" },	{ L'', L"e" },
		{ L'', L"x" },	{ L'', L"o" },	{ L'', L"k" },	{ L'', L"g" },
		{ L'', L"k" },	{ L'', L"g" },	{ L'', L"k" },	{ L'', L"g" },
		{ L'', L"k" },	{ L'', L"g" },	{ L'', L"k" },	{ L'', L"g" },
		{ L'', L"s" },	{ L'', L"z" },	{ L'', L"s" },	{ L'', L"j" },
		{ L'', L"s" },	{ L'', L"z" },	{ L'', L"s" },	{ L'', L"z" },
		{ L'', L"s" },	{ L'', L"z" },	{ L'', L"t" },	{ L'', L"d" },
		{ L'', L"t" },	{ L'', L"d" },	{ L'', L"t" },	{ L'', L"t" },
		{ L'', L"d" },	{ L'', L"t" },	{ L'', L"d" },	{ L'', L"t" },
		{ L'', L"d" },	{ L'', L"n" },	{ L'', L"n" },	{ L'', L"n" },
		{ L'', L"n" },	{ L'', L"n" },	{ L'', L"h" },	{ L'', L"b" },

		{ L'', L"p" },	{ L'', L"h" },	{ L'', L"b" },	{ L'', L"p" },
		{ L'', L"h" },	{ L'', L"b" },	{ L'', L"p" },	{ L'', L"h" },
		{ L'', L"b" },	{ L'', L"p" },	{ L'', L"h" },	{ L'', L"b" },
		{ L'', L"p" },	{ L'', L"m" },	{ L'', L"m" },	{ L'', L"m" },
		{ L'', L"m" },	{ L'', L"m" },	{ L'', L"x" },	{ L'', L"y" },
		{ L'', L"x" },	{ L'', L"y" },	{ L'', L"x" },	{ L'', L"y" },
		{ L'', L"r" },	{ L'', L"r" },	{ L'', L"r" },	{ L'', L"r" },
		{ L'', L"r" },	{ L'', L"x" },	{ L'', L"w" },	{ L'', L"x" },
		{ L'', L"x" },	{ L'', L"w" },	{ L'', L"n" },
	} ;
	int		i ;

	for (i = 0 ; i < sizeof (_rSkkKanaRomVector) / sizeof (_rSkkKanaRomVector [0]) ; i ++) {
		if (nCH == _rSkkKanaRomVector [i].nKana) {
			int		n ;
			n	= lstrlenW (_rSkkKanaRomVector [i].wstrRom) ;
			n	= (n > nOkuri)? nOkuri : n ;
			if (n > 0) 
				memcpy (pOkuri, _rSkkKanaRomVector [i].wstrRom, n * sizeof (WCHAR)) ;
			return	n ;
		}
	}
	return	0 ;
}

int
ImeConfig_iGetSkkShowAnnotationType (void)
{
	return	_snShowAnnotationType ;
}

BOOL
ImeConfig_bSkkEggLikeNewline (void) 
{
	return	_bEggLikeNewline ;
}

BOOL
ImeConfig_bSkkDeleteOkuriWhenQuit (void)
{
	return	_sbDeleteOkuriWhenQuit ;
}

BOOL
ImeConfig_bSkkDeleteImplesKakuteip (void) 
{
	return	_bDeleteImpliesKakutei ;
}

LPCWSTR
ImeConfig_pGetSkkHenkanShowCandidatesKeys (int* pnKeys)
{
	if (pnKeys != NULL)
		*pnKeys	= _snNumShowCandidateKeys ;
	return	_srwchShowCandidateKeys ;
}

BOOL
ImeConfig_bSkkNumericConversionp (void)
{
	return	_sbNumericConversion ;
}

BOOL
ImeConfig_bSkkNumConvertFloatp (void)
{
	return	_sbNumericFloat ;
}

BOOL
ImeConfig_bSkkCompCirculatep (void)
{
	return	_bCompCirculate ;
}

int
ImeConfig_iGetSkkKcodeCharset (void)
{
	return	_iKanjiCodeCharset ;
}

LPCWSTR
ImeConfig_pGetSkkInputByCodeMenuKeys1 (int* pnKeys)
{
	if (pnKeys != NULL) {
		*pnKeys	= _snNumInputCodeMenu1Keys ;
	}
	return	_srwchInputCodeMenu1Keys ;
}

LPCWSTR
ImeConfig_pGetSkkInputByCodeMenuKeys2 (int* pnKeys)
{
	if (pnKeys != NULL) {
		*pnKeys	= _snNumInputCodeMenu2Keys ;
	}
	return	_srwchInputCodeMenu2Keys ;
}

int
ImeConfig_iGetSkkOkuriChar (
	LPCWSTR					pwOkuriChar,
	int						nOkuriCharLen,
	LPWSTR					pwDest,
	int						nDestSize)
{
	int		i, nLen ;

	if (_iOkuriCharAlistType != OKURICHARTP_USERDEFINED)
		return	0 ;

	for (i = 0 ; i < _iNumOkuriCharAlist ; i ++) {
		if (wcsncmp (pwOkuriChar, _srOkuriCharAlist [i].m_bufLeft, nOkuriCharLen) == 0 &&
			_srOkuriCharAlist [i].m_bufLeft [nOkuriCharLen] == L'\0') {
			/*	hit */
			nLen	= MIN (nDestSize, (int) wcslen (_srOkuriCharAlist [i].m_bufRight)) ;
			memcpy (pwDest, _srOkuriCharAlist [i].m_bufRight, nLen * sizeof (WCHAR)) ;
			return	nLen ;
		}
	}
	return	0 ;
}

BOOL
ImeConfig_bSkkHenkanOkuriStrictlyp (void)
{
	return	_sbHenkanOkuriStrictly ;
}

BOOL
ImeConfig_bSkkHenkanStrictOkuriPrecedencep (void)
{
	return	_sbHenkanStrictOkuriPrecedence ;
}

/*	auto-okuri-process 𗘗p̂́Askkiserv łƎv邪Aꉞ̋Lq͓ĂB
 */
BOOL
ImeConfig_bSkkAutoOkuriProcessp (void)
{
	return	_sbAutoOkuriProcess ;
}

const CSkkRuleTreeNodeOutput*
ImeConfig_pGetOhRuleTreeNodeOutput	(void)
{
	return	_pOhOutput ;
}

int
ImeConfig_iSkkARefSkkJisx0208LatinVector (
	int						nCH, 
	LPWSTR					pResult,
	int						nResultSize)
{
	if (0 <= nCH && nCH < sizeof (_rstrJisx0208LatinVector) / sizeof (_rstrJisx0208LatinVector [0]) &&
		_rstrJisx0208LatinVector [nCH] != NULL) {
		int		n ;
		n	= lstrlenW (_rstrJisx0208LatinVector [nCH]) ;
		n	= (n > nResultSize)? nResultSize : n ;
		if (n > 0) 
			memcpy (pResult, _rstrJisx0208LatinVector [nCH], n * sizeof (WCHAR)) ;
		return	n ;
	}
	return	-1 ;	/* not hit */
}

/*	tB
 */
int
ImeConfig_iSkkRevRefSkkJisx0208LatinVector (
	int						nCH, 
	LPWSTR					pResult,
	int						nResultSize)
{
	int		i ;

	for (i = 0 ; i < sizeof (_rstrJisx0208LatinVector) / sizeof (_rstrJisx0208LatinVector [0]) ; i ++) {
		if (_rstrJisx0208LatinVector [i] != NULL && 
			*(_rstrJisx0208LatinVector [i] + 0) == nCH &&
			*(_rstrJisx0208LatinVector [i] + 1) == L'\0') {
			if (nResultSize > 0)
				*pResult	= i ;
			return	1 ;
		}
	}
	return	-1 ;	/* not hit */
}

BOOL
ImeConfig_bSkkAutoInsertParen (void)
{
	return	_bAutoInsertParen ;
}

int
ImeConfig_iSkkAssocSkkAutoParenStringAlist	(
	LPCWSTR					pwString,
	int						nStringLen,
	LPWSTR					pwResult,
	int						nResultSize)
{
	int		i ;

	for (i = 0 ; i < _iNumBracketParen ; i ++) {
		if (! wcsncmp (pwString, _srBracketParen [i].m_bufLeft, nStringLen) && 
			_srBracketParen [i].m_bufLeft [nStringLen]	== L'\0') {
			int		n ;
			n	= lstrlenW (_srBracketParen [i].m_bufRight) ;
			n	= (n > nResultSize)? nResultSize : n ;
			if (n > 0) 
				memcpy (pwResult, _srBracketParen [i].m_bufRight, n * sizeof (WCHAR)) ;
			return	n ;
		}
	}
	return	-1 ;	/* not hit */
}

/*	̐ݒ͍̂ƂJX^}CYłȂB FALSE ɂĂAł̂cH
 */
BOOL
ImeConfig_bSkkAllowsSpacesNewlinesAndTabs	(void)
{
	return	_bAllowsSpacesNewlinesAndTabs ;
}

LPCWSTR
ImeConfig_pGetCurrentTouten (
	int								iKutoutenType,
	int*							pnLength)
{
	unsigned int		nIndex ;

	nIndex	= (unsigned int)iKutoutenType % _iNumKutouten ;
	if (pnLength != NULL)
		*pnLength	= lstrlenW (_srKutouten [nIndex].m_bufLeft) ;
	return	_srKutouten [nIndex].m_bufLeft ;
}

LPCWSTR
ImeConfig_pGetCurrentKuten (
	int								iKutoutenType,
	int*							pnLength)
{
	unsigned int		nIndex ;

	nIndex	= (unsigned int)iKutoutenType % _iNumKutouten ;
	if (pnLength != NULL)
		*pnLength	= lstrlenW (_srKutouten [nIndex].m_bufRight) ;
	return	_srKutouten [nIndex].m_bufRight ;
}

int
ImeConfig_iGetNumberOfKutotens (void)
{
	return	_iNumKutouten ;
}

/*	Newline -> Kakutei ̌Apoint-marker  buffer ̍Ōֈړ邩ۂB
 *	shift-count ̐Aꂪ TRUE ƁuComposition ̑SmvɌB
 */
BOOL
ImeConfig_bSkkIsNewlineKakuteiAllp (void)
{
	return	_bNewlineKakuteiAll ;
}

/*	I CompositionString mς݂Ƃđ邩ǂ肷B
 *	{IɁuobt@̐擪vupoint-marker̈ʒuvuϊJnʒuv
 *	uJnʒuv̒ōŏ̈ʒu܂ŃVtgB
 */
BOOL
ImeConfig_bSkkCompositionAutoShiftp (void)
{
	return	_bCompositionAutoShift ;
}

const struct CImeKeymap*
ImeConfig_pGetMajorModeMap (void) 
{
	return	&_sMajorModeMap ;
}

const struct CImeKeymap*
ImeConfig_pGetSkkJModeMap (void)
{
	return	&_sSkkJModeMap ;
}

const struct CImeKeymap*
ImeConfig_pGetSkkLatinModeMap (void)
{
	return	&_sSkkLatinModeMap ;
}

const struct CImeKeymap*
ImeConfig_pGetSkkJisx0208LatinModeMap (void)
{
	return	&_sSkkJisx0208LatinModeMap ;
}

const struct CImeKeymap*
ImeConfig_pGetSkkAbbrevModeMap (void)
{
	return	&_sSkkAbbrevModeMap ;
}

const struct CImeKeymap*
ImeConfig_pGetMinibufferMinorModeMap (void)
{
	return	&_sMinibufferMinorModeMap ;
}

const MYCOLORFACESET*
ImeConfig_pGetColorFaceSet (void)
{
	return	_srImeColorFaces ;
}

int
ImeConfig_iGetCountHenkanShowChange (void)
{
	return	_snShowCandListCount ;
}

/*========================================================================
 *	private functions (for ZenkakuVector)
 */
BOOL
imeConfig_bLoadZenkakuVector (void)
{
	HKEY	hSubKey ;
	int		i, nLength ;
	BOOL	bInitialized	= FALSE ;

	imeConfig_vClearZenkakuVector () ;

	/*	WXgɃL[݂Ȃ΁AftHgݒ肷B
	 */
	if (RegOpenKeyExW (HKEY_CURRENT_USER, REGPATH_ZENKAKUVECTOR, 0, KEY_READ, &hSubKey) == ERROR_SUCCESS) {
		LONG 	lResult ;
		DWORD	dwType, cbData ;
		LPWSTR	pwData ;
		LPCWSTR	pwSrc ;

		lResult	= RegQueryValueExW (hSubKey, REGINFO_ZENKAKUVECTOR, NULL, &dwType, NULL, &cbData) ;
		if (lResult != ERROR_SUCCESS) 
			goto	skip_error ;
		if (dwType != REG_MULTI_SZ) 
			goto	skip_error ;

		pwData	= (LPWSTR) new WCHAR [cbData] ;
		if (pwData == NULL)
			goto	skip_error ;

		(void) RegQueryValueExW (hSubKey, REGINFO_ZENKAKUVECTOR, NULL, &dwType, (BYTE*)pwData, &cbData) ;

		pwSrc	= pwData ;
		while (*pwSrc != TEXT ('\0')) {
			LPCWSTR	pwBase ;
			int		nChara, nCH ;

			/*	ŏ3LN^[R[hA
			 *	񂪂̃R[hœ͂镶A
			 */
			nCH		= *pwSrc ++ ;
			if (nCH < TEXT ('0') || nCH > TEXT ('9'))
				goto	skip_error ;
			nChara	= nCH - TEXT ('0') ;

			nCH		= *pwSrc ++ ;
			if (nCH < TEXT ('0') || nCH > TEXT ('9'))
				goto	skip_error ;
			nChara	= nChara * 10 + (nCH - TEXT ('0')) ;

			nCH		= *pwSrc ++ ;
			if (nCH < TEXT ('0') || nCH > TEXT ('9'))
				goto	skip_error ;
			nChara	= nChara * 10 + (nCH - TEXT ('0')) ;
			if (nChara < 0 || nChara >= MYARRAYSIZE (_rstrJisx0208LatinVector))
				goto	skip_error ;

			pwBase	= pwSrc ;
			while (*pwSrc != TEXT ('\0'))
				pwSrc	++ ;

			if (_rstrJisx0208LatinVector [nChara] != NULL) {
				delete[]	_rstrJisx0208LatinVector [nChara] ;
			}
			_rstrJisx0208LatinVector [nChara]	= (LPWSTR) new WCHAR [(pwSrc - pwBase) + 1] ;
			if (_rstrJisx0208LatinVector [nChara] == NULL)
				break ;
			lstrcpyW (_rstrJisx0208LatinVector [nChara], pwBase) ;
			pwSrc	++ ;
		}
		bInitialized	= TRUE ;
skip_error:
		RegCloseKey (hSubKey) ;
	}
	if (! bInitialized) {
		for (i = 0 ; i < MYARRAYSIZE (_rstrJisx0208LatinVector) ; i ++) {
			if (_rstrDefaultJisx0208LatinVector [i] != NULL) {
				nLength	= lstrlenW (_rstrDefaultJisx0208LatinVector [i]) ;
				_rstrJisx0208LatinVector [i]	= (LPWSTR) new WCHAR [nLength + 1] ;
				if (_rstrJisx0208LatinVector [i] != NULL) {
					lstrcpyW (_rstrJisx0208LatinVector [i], _rstrDefaultJisx0208LatinVector [i]) ;
				}
			} else {
				_rstrJisx0208LatinVector [i]	= NULL ;
			}
		}
	}
	return	TRUE ;
}

void
imeConfig_vClearZenkakuVector (void)
{
	int		i ;

	for (i = 0 ; i < MYARRAYSIZE (_rstrJisx0208LatinVector) ; i ++) {
		if (_rstrJisx0208LatinVector [i] != NULL) {
			delete[]	_rstrJisx0208LatinVector [i] ;
			_rstrJisx0208LatinVector [i]	= NULL ;
		}
	}
	return ;
}

/*========================================================================
 *	private functions (for Keybind)
 */
static	void	imeConfig_vInitializeMajorModeMap			(void) ;
static	void	imeConfig_vInitializeSkkJModeMap			(void) ;
static	void	imeConfig_vInitializeSkkLatinModeMap		(void) ;
static	void	imeConfig_vInitializeSkkJisx0208LatinModeMap(void) ;
static	void	imeConfig_vInitializeSkkAbbrevModeMap		(void) ;
static	void	imeConfig_vInitializeMinibufferMinorModeMap (void) ;

BOOL
imeConfig_bLoadKeymap (void)
{
	static	LPCWSTR	srKeymapRegistryNames []	= {
		REGINFO_MAJORMODEMAP,
		REGINFO_JMODEMAP,
		REGINFO_LATINMODEMAP,
		REGINFO_ZENKAKUMODEMAP,	/* jisx0208-latin-mode-map */
		REGINFO_ABBREVMODEMAP,
	} ;
	static	struct CImeKeymap*	rpKeymaps []	= {
		&_sMajorModeMap,
		&_sSkkJModeMap,
		&_sSkkLatinModeMap,
		&_sSkkJisx0208LatinModeMap,
		&_sSkkAbbrevModeMap,
	} ;
	/*	L[̈BControl + F1 ƂB(VKEYCODE, MODIFIER, FUNCTION) ̃yA
	 *	ȂB
	 */
	static	LPCTSTR	srKeymapExtraRegisterNames []	= {
		REGINFO_MAJORMODEMAP_EX,
		REGINFO_JMODEMAP_EX,
		REGINFO_LATINMODEMAP_EX,
		REGINFO_ZENKAKUMODEMAP_EX,	/* jisx0208-latin-mode-map */
		REGINFO_ABBREVMODEMAP_EX,
	} ;
	HKEY	hSubKey ;
	int		i ;
	BOOL	bRetval	= FALSE ;
	BOOL	bExistUserDefinedKeymap					= FALSE ;
	BOOL	bExistUserDefinedStartHenkanKey			= FALSE ;
	BOOL	bExistUserDefinedCompletionKey			= FALSE ;
	BOOL	bExistUserDefinedSetHenkanPointSubrKey	= FALSE ;
	BOOL	bExistUserDefinedSpecialMidashiCharKey	= FALSE ;

	if (RegOpenKeyExW (HKEY_CURRENT_USER, REGPATH_KEYMAP, 0, KEY_READ, &hSubKey) == ERROR_SUCCESS) {
		struct CImeKeymap*	pKeymap ;
		LONG 	lResult ;
		DWORD	dwType, cbData, dwValue ;

		cbData	= sizeof (dwValue) ;
		if (RegQueryValueExW (hSubKey, REGINFO_KEYMAP_TYPE, NULL, &dwType, (BYTE*)&dwValue, &cbData) != ERROR_SUCCESS || dwType != REG_DWORD) 
			goto	skip_error ;
		_siKeybindType	= (int) dwValue ;

		for (i = 0 ; i < MYARRAYSIZE (srKeymapRegistryNames) ; i ++) {
			lResult	= RegQueryValueExW (hSubKey, srKeymapRegistryNames [i], NULL, &dwType, NULL, &cbData) ;
			if (lResult != ERROR_SUCCESS) 
				break ;
			if (dwType != REG_BINARY || cbData != MAX_KEYBINDS) 
				goto	skip_error ;

			pKeymap	= rpKeymaps [i] ;
			(void) RegQueryValueExW (hSubKey, srKeymapRegistryNames [i], NULL, &dwType, (BYTE*)pKeymap->m_rbyBaseMap, &cbData) ;

			/* ̑̃oCh͋ɂĂB*/
			pKeymap->m_nKeyBinds	= 0 ;
			pKeymap->m_pKeyBinds	= NULL ;
		}
		if (i >= MYARRAYSIZE (srKeymapRegistryNames))
			bExistUserDefinedKeymap	= TRUE ;

		/*	L[̓o^B
		 */
		if (bExistUserDefinedKeymap) {
			BYTE	rbBuffer [512] ;
			BYTE*	pbBuffer	= NULL ;
			DWORD	iBufSize ;

			pbBuffer	= rbBuffer ;
			iBufSize	= sizeof (rbBuffer) ;
			for (i = 0 ; i < MYARRAYSIZE (srKeymapExtraRegisterNames) ; i ++) {
				int				iNumKeyBinds, j ;
				const BYTE*		pbData ;
				struct CImeKeyBind*	pKeyBind ;

				/* ̑̃oCh͋ɂĂB*/
				lResult	= RegQueryValueEx (hSubKey, srKeymapExtraRegisterNames [i], NULL, &dwType, NULL, &cbData) ;
				if (lResult != ERROR_SUCCESS || dwType != REG_BINARY)
					continue ;
				if (cbData > iBufSize) {
					if (pbBuffer != rbBuffer) {
						delete[]	pbBuffer ;
					}
					pbBuffer	= new BYTE [cbData] ;
					if (pbBuffer == NULL) 
						break ;
					iBufSize	= cbData ;
				}
				(void) RegQueryValueEx (hSubKey, srKeymapExtraRegisterNames [i], NULL, &dwType, pbBuffer, &cbData) ;

				/*
				 */
				iNumKeyBinds	= cbData / (4 + 2 + 2) ;	/* VKEY(4), MODIFIER(2), FUNCNO(2) */
				if (iNumKeyBinds <= 0)
					continue ;

				rpKeymaps [i]->m_pKeyBinds	= new CImeKeyBind [iNumKeyBinds] ;
				if (rpKeymaps [i]->m_pKeyBinds == NULL) {
					/* error */
					break ;
				}
				rpKeymaps [i]->m_nKeyBinds	= iNumKeyBinds ;

				pbData		= pbBuffer ;
				pKeyBind	= rpKeymaps [i]->m_pKeyBinds ;
				for (j = 0 ; j < iNumKeyBinds ; j ++) {
					unsigned int	uVKey, uModifier ;
					int				iFuncNo ;

					uVKey		= (unsigned int) *pbData ++ ;
					uVKey		= uVKey | ((unsigned int) *pbData ++ <<  8) ;
					uVKey		= uVKey | ((unsigned int) *pbData ++ << 16) ;
					uVKey		= uVKey | ((unsigned int) *pbData ++ << 24) ;
					uModifier	= (unsigned int) *pbData ++ ;
					uModifier	= uModifier | ((unsigned int) *pbData ++ << 8) ;
					iFuncNo		= (unsigned int) *pbData ++ ;
					iFuncNo		= iFuncNo | ((unsigned int) *pbData ++) ;
					if (iFuncNo < 0 || iFuncNo >= NFUNC_INVALID_CHAR) 
						continue ;	/* skip */
					pKeyBind->m_nKeyCode		= uVKey ;
					pKeyBind->m_uKeyMask		= uModifier ;
					pKeyBind->m_nKeyFunction	= iFuncNo ;
					pKeyBind	++ ;
				}
				/* realloc Ƃ낾ǁc */
				rpKeymaps [i]->m_nKeyBinds	= pKeyBind - rpKeymaps [i]->m_pKeyBinds ;
			}
			if (pbBuffer != rbBuffer && pbBuffer != NULL) {
				delete[]	pbBuffer ;
				pbBuffer	= NULL ;
			}
		}

		cbData	= sizeof (dwValue) ;
		if (RegQueryValueExW (hSubKey, REGINFO_STARTHENKANKEY_TYPE, NULL, &dwType, (BYTE*)&dwValue, &cbData) != ERROR_SUCCESS || dwType != REG_DWORD) 
			goto	skip_error ;
		_siStartHenkanKeyType	= (int) dwValue ;
		cbData	= sizeof (_srbyStartHenkanKeys) ;
		if (RegQueryValueExW (hSubKey, REGINFO_STARTHENKANKEY, NULL, &dwType, (BYTE*)_srbyStartHenkanKeys, &cbData) != ERROR_SUCCESS) {
			/* L[݂ȂȂAJX^ڂ͂Ȃōς܂B*/
			bExistUserDefinedStartHenkanKey	= FALSE ;
		} else {
			if (dwType != REG_BINARY)
				goto	skip_error ;
			_siNumStartHenkanKeys				= (int) cbData ;
			bExistUserDefinedStartHenkanKey	= TRUE ;
		}

		cbData	= sizeof (dwValue) ;
		if (RegQueryValueExW (hSubKey, REGINFO_COMPLETIONRELATEDKEY_TYPE, NULL, &dwType, (BYTE*)&dwValue, &cbData) != ERROR_SUCCESS || dwType != REG_DWORD) 
			goto	skip_error ;
		_siCompletionRelatedKeyType	= (int) dwValue ;
		if (RegQueryValueExW (hSubKey, REGINFO_TRYCOMPLETIONKEY, NULL, &dwType, (BYTE*)_srbyTryCompletionKeys, &cbData) != ERROR_SUCCESS) {
			/* L[݂ȂȂAJX^ڂ͂Ȃōς܂B*/
		} else {
			if (dwType != REG_BINARY)
				goto	skip_error ;
			_siNumTryCompletionKeys				= (int) cbData ;
			bExistUserDefinedCompletionKey	= TRUE ;
		}
		if (RegQueryValueExW (hSubKey, REGINFO_PREVIOUSCOMPLETIONKEY, NULL, &dwType, (BYTE*)_srbyPreviousCompletionKeys, &cbData) != ERROR_SUCCESS) {
			/* L[݂ȂȂAJX^ڂ͂Ȃōς܂B*/
		} else {
			if (dwType != REG_BINARY)
				goto	skip_error ;
			_siNumPreviousCompletionKeys		= (int) cbData ;
			bExistUserDefinedCompletionKey	= TRUE ;
		}
		if (RegQueryValueExW (hSubKey, REGINFO_NEXTCOMPLETIONKEY, NULL, &dwType, (BYTE*)_srbyNextCompletionKeys, &cbData) != ERROR_SUCCESS) {
			/* L[݂ȂȂAJX^ڂ͂Ȃōς܂B*/
		} else {
			if (dwType != REG_BINARY)
				goto	skip_error ;
			_siNumNextCompletionKeys			= (int) cbData ;
			bExistUserDefinedCompletionKey	= TRUE ;
		}

		cbData	= sizeof (dwValue) ;
		if (RegQueryValueExW (hSubKey, REGINFO_SETHENKANPOINTSUBRKEY_TYPE, NULL, &dwType, (BYTE*)&dwValue, &cbData) != ERROR_SUCCESS || dwType != REG_DWORD) 
			goto	skip_error ;
		_siSetHenkanPointSubrKeyType	= (int) dwValue ;
		cbData	= sizeof (_srbySetHenkanPointSubrKeys) ;
		if (RegQueryValueExW (hSubKey, REGINFO_SETHENKANPOINTSUBRKEY, NULL, &dwType, (BYTE*)_srbySetHenkanPointSubrKeys, &cbData) != ERROR_SUCCESS) {
			/* L[݂ȂȂAJX^ڂ͂Ȃōς܂B*/
			bExistUserDefinedSetHenkanPointSubrKey	= FALSE ;
		} else {
			if (dwType != REG_BINARY)
				goto	skip_error ;
			_siNumSetHenkanPointSubrKeys				= (int) cbData ;
			bExistUserDefinedSetHenkanPointSubrKey	= TRUE ;
		}
		cbData	= sizeof (dwValue) ;
		if (RegQueryValueExW (hSubKey, REGINFO_SPECIALMIDASHICHAR_TYPE, NULL, &dwType, (BYTE*)&dwValue, &cbData) != ERROR_SUCCESS || dwType != REG_DWORD)
			goto	skip_error ;
		_siSpecialMidashiCharKeyType	= (int) dwValue ;
		cbData	= sizeof (_srbySpecialMidashiCharKeys) ;
		if (RegQueryValueExW (hSubKey, REGINFO_SPECIALMIDASHICHAR, NULL, &dwType, (BYTE*)_srbySpecialMidashiCharKeys, &cbData) != ERROR_SUCCESS) {
			/* L[݂ȂȂAJX^ڂ͂Ȃōς܂B*/
			bExistUserDefinedSpecialMidashiCharKey	= FALSE ;
		} else {
			if (dwType != REG_BINARY)
				goto	skip_error ;
			_siNumSpecialMidashiCharKeys				= (int) cbData ;
			bExistUserDefinedSpecialMidashiCharKey	= TRUE ;
		}

		cbData	= sizeof (dwValue) ;
		if (RegQueryValueExW (hSubKey, REGINFO_EGGLIKENEWLINE, NULL, &dwType, (BYTE*)&dwValue, &cbData) != ERROR_SUCCESS) {
			goto	skip_error ;
		} else {
			if (dwType != REG_DWORD)
				goto	skip_error ;
			_bEggLikeNewline	= (dwValue != 0) ;
		}
		cbData	= sizeof (dwValue) ;
		if (RegQueryValueExW (hSubKey, REGINFO_NEWLINEKAKUTEIALL, NULL, &dwType, (BYTE*)&dwValue, &cbData) != ERROR_SUCCESS) {
			goto	skip_error ;
		} else {
			if (dwType != REG_DWORD)
				goto	skip_error ;
			_bNewlineKakuteiAll	= (dwValue != 0) ;
		}
		bRetval	= TRUE ;
skip_error:
		RegCloseKey (hSubKey) ;
	}

	/* f[^ςłȂAX̗vf`FbNB*/
	if (bRetval) {
		for (i = 0 ; i < MYARRAYSIZE (rpKeymaps) ; i ++) {
			struct CImeKeymap*	pKeymap ;
			int		j ;

			pKeymap	= rpKeymaps [i] ;
			for (j = 0 ; j < MAX_KEYBINDS ; j ++) {
				if (pKeymap->m_rbyBaseMap [j] < 0 || pKeymap->m_rbyBaseMap [j] >= NUM_SELECTABLE_FUNCTIONS) {
					pKeymap->m_rbyBaseMap [j]	= NFUNC_INVALID_CHAR ;
				}
			}
		}
		if (_siKeybindType == KEYBINDTP_USERDEFINED && ! bExistUserDefinedKeymap)
			_siKeybindType	= KEYBINDTP_DEFAULT ;
		if (_siStartHenkanKeyType == KEYBINDTP_USERDEFINED && ! bExistUserDefinedStartHenkanKey)
			_siStartHenkanKeyType	= KEYBINDTP_DEFAULT ;
		if (_siCompletionRelatedKeyType == KEYBINDTP_USERDEFINED && ! bExistUserDefinedCompletionKey)
			_siCompletionRelatedKeyType	= KEYBINDTP_DEFAULT ;
		if (_siSetHenkanPointSubrKeyType == KEYBINDTP_USERDEFINED && !bExistUserDefinedSetHenkanPointSubrKey) 
			_siSetHenkanPointSubrKeyType	= KEYBINDTP_DEFAULT ;
		if (_siSpecialMidashiCharKeyType == KEYBINDTP_USERDEFINED && !bExistUserDefinedSpecialMidashiCharKey) 
			_siSpecialMidashiCharKeyType	= KEYBINDTP_DEFAULT ;
	} else {
		/* [hɎŝŁAftHg̐ݒɂB*/
		_siKeybindType					= KEYBINDTP_DEFAULT ;
		_siStartHenkanKeyType			= KEYBINDTP_DEFAULT ;
		_siCompletionRelatedKeyType		= KEYBINDTP_DEFAULT ;
		_siSetHenkanPointSubrKeyType	= KEYBINDTP_DEFAULT ;
		_siSpecialMidashiCharKeyType	= KEYBINDTP_DEFAULT ;

		_bEggLikeNewline				= FALSE ;
		_bNewlineKakuteiAll				= TRUE ;
	}
	/*	L[}bv̏B*/
	if (_siKeybindType == KEYBINDTP_DEFAULT) {
		imeConfig_vInitializeMajorModeMap () ;
		imeConfig_vInitializeSkkJModeMap () ;
		imeConfig_vInitializeSkkLatinModeMap () ;
		imeConfig_vInitializeSkkJisx0208LatinModeMap () ;
		imeConfig_vInitializeSkkAbbrevModeMap () ;	
	}
	imeConfig_vInitializeMinibufferMinorModeMap () ;
	return	TRUE ;
}

void
imeConfig_vInitializeMajorModeMap (void)
{
	static BYTE		_srbDefaultMajorModeMap []	= {
		NFUNC_SET_MARK_COMMAND,				/* C-@ */
		NFUNC_BEGINNING_OF_LINE,			/* C-a */
		NFUNC_BACKWARD_CHAR,				/* C-b */
		NFUNC_INVALID_CHAR,					//NFUNC_MODE_SPECIFIC_COMMAND_PREFIX,	/* C-c */
		NFUNC_DELETE_CHAR,					/* C-d */
		NFUNC_END_OF_LINE,					/* C-e */
		NFUNC_FORWARD_CHAR,					/* C-f */
		NFUNC_KEYBOARD_QUIT,				/* C-g */
		NFUNC_BACKWARD_DELETE_CHAR,			/* C-h */
		NFUNC_INVALID_CHAR,					//NFUNC_INDENT_FOR_TAB_COMMAND,			/* C-i */
		NFUNC_NEWLINE,						//NFUNC_NEWLINE_AND_INDENT,				/* C-j */
		NFUNC_KILL_LINE,					/* C-k */
		NFUNC_INVALID_CHAR,					//NFUNC_RECENTER,						/* C-l */
		NFUNC_NEWLINE,						/* C-m */
		NFUNC_INVALID_CHAR,					//NFUNC_NEXT_LINE,						/* C-n */
		NFUNC_INVALID_CHAR,					//NFUNC_OPEN_LINE,						/* C-o */
		NFUNC_INVALID_CHAR,					//NFUNC_PREVIOUS_LINE,					/* C-p */	
		NFUNC_INVALID_CHAR,					//NFUNC_QUATED_INSERT,					/* C-q */
		NFUNC_INVALID_CHAR,					//NFUNC_ISEARCH_BACKWARD,				/* C-r */
		NFUNC_INVALID_CHAR,					//NFUNC_ISEARCH_FORWARD,				/* C-s */
		NFUNC_TRANSPOSE_CHARS,				/* C-t */
		NFUNC_INVALID_CHAR,					//FUNC_UNIVERSAL_ARGUMENT,				/* C-u */
		NFUNC_INVALID_CHAR,					//NFUNC_SCROLL_UP,						/* C-v */
		NFUNC_KILL_REGION,					/* C-w */
		NFUNC_INVALID_CHAR,					//NFUNC_CONTROL_X_PREFIX,				/* C-x */
		NFUNC_YANK,							/* C-y */
		NFUNC_INVALID_CHAR,					//NFUNC_SCROLL_DOWN,					/* C-z */
		NFUNC_INVALID_CHAR,					//NFUNC_PREFIX_COMMAND,					/* C-[ */
		NFUNC_TOGGLE_IME,					/* C-\\ */
		NFUNC_ABORT_RECURSIVE_EDIT,			/* C-] */
		NFUNC_INVALID_CHAR,					//NFUNC_UNDO,							/* C-_ */
	} ;
	int	i ;

	for (i = 0 ; i < MYARRAYSIZE (_sMajorModeMap.m_rbyBaseMap) ; i ++) 
		_sMajorModeMap.m_rbyBaseMap [i]	= NFUNC_INVALID_CHAR ;
	for (i = 0 ; i < MYARRAYSIZE (_srbDefaultMajorModeMap) ; i ++) 
		_sMajorModeMap.m_rbyBaseMap [i]	= _srbDefaultMajorModeMap [i] ;
	for (i = 32 ; i < 127 ; i ++) 
		_sMajorModeMap.m_rbyBaseMap [i]	= NFUNC_SELF_INSERT_CHARACTER ;
	_sMajorModeMap.m_pKeyBinds	= NULL ;
	_sMajorModeMap.m_nKeyBinds	= 0 ;
	return ;
}

void
imeConfig_vInitializeSkkJModeMap (void)
{
	int		i ;

	for (i = 0 ; i < MYARRAYSIZE (_sSkkJModeMap.m_rbyBaseMap) ; i ++) {
		_sSkkJModeMap.m_rbyBaseMap [i]	= NFUNC_INVALID_CHAR ;
	}
	for (i = 32 ; i < 127 ; i ++) {
		_sSkkJModeMap.m_rbyBaseMap [i]	= NFUNC_SKK_INSERT ;
	}
	_sSkkJModeMap.m_rbyBaseMap [10]	= NFUNC_SKK_KAKUTEI ;

	/*	previous-candidate-char ɂׂAkeybind  previous-candidate-char 
	 *	߂悤ɂׂBǂ炪̂B҂IȂŔAǂ
	 *	minor-mode-map 𗘗pΗǂ̂Ȃ炩H
	 */
	_sSkkJModeMap.m_rbyBaseMap ['x']	= NFUNC_SKK_PREVIOUS_CANDIDATE ;

	for (i = 0 ; i < MYARRAYSIZE (_sMajorModeMap.m_rbyBaseMap) ; i ++) {
		if (_sMajorModeMap.m_rbyBaseMap [i] == NFUNC_BACKWARD_DELETE_CHAR) {
			_sSkkJModeMap.m_rbyBaseMap [i]	= NFUNC_SKK_DELETE_BACKWARD_CHAR ;
		}
	}
	/*	try-completion-char  skk-insert ɂ킹B
	 *	try-completion-char  keybind ɂ邩cB[Ał try-completion ̓
	 *	 skk-insert ƓɂĂ (function code ͈ႤǁA͓)A
	 *	keybind  try-completion Ȃ try-completion-charp  t ԂƂ̂́H
	 *
	 *	Aabbrev-map ͑f try-completion Ȃ̂ɁA skk-insert oRƂ̂
	 *	CɂȂcB闝Rl try-completion ̂͊댯B
	 */
	_sSkkJModeMap.m_rbyBaseMap ['\t']	= NFUNC_SKK_INSERT ;
	_sSkkJModeMap.m_pKeyBinds	= NULL ;
	_sSkkJModeMap.m_nKeyBinds	= 0 ;
	return ;
}

void
imeConfig_vInitializeSkkLatinModeMap (void)
{
	int		i ;
	for (i = 0 ; i < MYARRAYSIZE (_sSkkLatinModeMap.m_rbyBaseMap) ; i ++)
		_sSkkLatinModeMap.m_rbyBaseMap [i]	= NFUNC_INVALID_CHAR ;

	/* skk-kakutei-key Đݒ肵ȂƂȂB*/
	_sSkkLatinModeMap.m_rbyBaseMap [10]	= NFUNC_SKK_KAKUTEI ;

	_sSkkLatinModeMap.m_pKeyBinds	= NULL ;
	_sSkkLatinModeMap.m_nKeyBinds	= 0 ;
	return ;
}

void
imeConfig_vInitializeSkkJisx0208LatinModeMap (void)
{
	int		i ;
	for (i = 0 ; i < MYARRAYSIZE (_sSkkJisx0208LatinModeMap.m_rbyBaseMap) ; i ++)
		_sSkkJisx0208LatinModeMap.m_rbyBaseMap [i]	= NFUNC_INVALID_CHAR ;

	for (i = 0 ; i < 128 ; i ++) {
		/*	LatinVector ̏ɍsĂȂ΂ȂȂB*/
		if (_rstrJisx0208LatinVector [i] != NULL) 
			_sSkkJisx0208LatinModeMap.m_rbyBaseMap [i]	= NFUNC_SKK_JISX0208_LATIN_INSERT ;
	}
	_sSkkJisx0208LatinModeMap.m_rbyBaseMap [17]	= NFUNC_SKK_LATIN_HENKAN ;	/* \C-q */

	/* skk-kakutei-key Đݒ肵ȂƂȂB*/
	_sSkkJisx0208LatinModeMap.m_rbyBaseMap [10]	= NFUNC_SKK_KAKUTEI ;
	/* skk-backward-and-set-henkan-point-char ́c 2stroke key ͎ĂȂcB*/

	_sSkkJisx0208LatinModeMap.m_pKeyBinds	= NULL ;
	_sSkkJisx0208LatinModeMap.m_nKeyBinds	= 0 ;
	return ;
}

void
imeConfig_vInitializeSkkAbbrevModeMap (void)
{
	int		i ;

	for (i = 0 ; i < MYARRAYSIZE (_sSkkAbbrevModeMap.m_rbyBaseMap) ; i ++)
		_sSkkAbbrevModeMap.m_rbyBaseMap [i]	= NFUNC_INVALID_CHAR ;

	_sSkkAbbrevModeMap.m_rbyBaseMap ['.']	= NFUNC_SKK_ABBREV_PERIOD ;
	_sSkkAbbrevModeMap.m_rbyBaseMap [',']	= NFUNC_SKK_ABBREV_COMMA ;
	_sSkkAbbrevModeMap.m_rbyBaseMap [17]	= NFUNC_SKK_TOGGLE_CHARACTERS ;

	/* skk-kakutei-key Đݒ肵ȂƂȂB*/
	_sSkkAbbrevModeMap.m_rbyBaseMap [10]	= NFUNC_SKK_KAKUTEI ;
	/* skk-start-henkan-char Đݒ肵ȂƂȂB*/
	_sSkkAbbrevModeMap.m_rbyBaseMap [' ']	= NFUNC_SKK_START_HENKAN ;

	for (i = 0 ; i < MYARRAYSIZE (_sMajorModeMap.m_rbyBaseMap) ; i ++) {
		if (_sMajorModeMap.m_rbyBaseMap [i] == NFUNC_BACKWARD_DELETE_CHAR) {
			_sSkkAbbrevModeMap.m_rbyBaseMap [i]	= NFUNC_SKK_DELETE_BACKWARD_CHAR ;
		}
	}
	_sSkkAbbrevModeMap.m_rbyBaseMap ['\t']	= NFUNC_SKK_TRY_COMPLETION ;

	_sSkkAbbrevModeMap.m_pKeyBinds	= NULL ;
	_sSkkAbbrevModeMap.m_nKeyBinds	= 0 ;
	return ;
}

void
imeConfig_vInitializeMinibufferMinorModeMap (void)
{
	struct CImeKeyBind*	pKeyBind ;
	int		i ;

	for (i = 0 ; i < MYARRAYSIZE (_sMinibufferMinorModeMap.m_rbyBaseMap) ; i ++)
		_sMinibufferMinorModeMap.m_rbyBaseMap [i]	= NFUNC_INVALID_CHAR ;
	_sMinibufferMinorModeMap.m_nKeyBinds	= 0 ;
	_sMinibufferMinorModeMap.m_pKeyBinds	= NULL ;

	for (i = 0 ; i < MYARRAYSIZE (_sMajorModeMap.m_rbyBaseMap) ; i ++) {
		if (_sMajorModeMap.m_rbyBaseMap [i] == NFUNC_NEWLINE) {
			imeConfig_bDefineKey (&_sMinibufferMinorModeMap, i, 0, FALSE, NFUNC_EXIT_RECURSIVE_EDIT) ;
		} else if (_sMajorModeMap.m_rbyBaseMap [i] == NFUNC_KEYBOARD_QUIT) {
			imeConfig_bDefineKey (&_sMinibufferMinorModeMap, i, 0, FALSE, NFUNC_ABORT_RECURSIVE_EDIT) ;
		}
	}
	if (_sMajorModeMap.m_nKeyBinds > 0) {
		pKeyBind	= _sMajorModeMap.m_pKeyBinds ;
		for (i = 0 ; i < _sMajorModeMap.m_nKeyBinds ; i ++) {
			if (pKeyBind->m_nKeyFunction  == NFUNC_NEWLINE) {
				imeConfig_bDefineKey (&_sMinibufferMinorModeMap, pKeyBind->m_nKeyCode, pKeyBind->m_uKeyMask, TRUE, NFUNC_EXIT_RECURSIVE_EDIT) ;
			} else if (pKeyBind->m_nKeyFunction == NFUNC_KEYBOARD_QUIT) {
				imeConfig_bDefineKey (&_sMinibufferMinorModeMap, pKeyBind->m_nKeyCode, pKeyBind->m_uKeyMask, TRUE, NFUNC_ABORT_RECURSIVE_EDIT) ;
			}
			pKeyBind	++ ;
		}
	}
	for (i = 0 ; i < MYARRAYSIZE (_sSkkJModeMap.m_rbyBaseMap) ; i ++) {
		if (_sSkkJModeMap.m_rbyBaseMap [i] == NFUNC_SKK_KAKUTEI) 
			imeConfig_bDefineKey (&_sMinibufferMinorModeMap, i, 0, FALSE, NFUNC_SKK_KAKUTEI) ;
	}
	if (_sSkkJModeMap.m_nKeyBinds > 0) {
		pKeyBind	= _sSkkJModeMap.m_pKeyBinds ;
		for (i = 0 ; i < _sSkkJModeMap.m_nKeyBinds ; i ++) {
			if (pKeyBind->m_nKeyFunction == NFUNC_SKK_KAKUTEI) 
				imeConfig_bDefineKey (&_sMinibufferMinorModeMap, pKeyBind->m_nKeyCode, pKeyBind->m_uKeyMask, TRUE, NFUNC_SKK_KAKUTEI) ;
			pKeyBind	++ ;
		}
	}
	return ;
}

BOOL
imeConfig_bDefineKey (
	struct CImeKeymap*	pKeymap,
	int					nKeyCode,
	unsigned int		uKeyMask,
	BOOL				bExtended,
	int					nKeyFunction)
{
	struct CImeKeyBind*	pKeyBind ;
	struct CImeKeyBind*	pNewKeyBind ;
	int		i ;

	if (pKeymap == NULL)
		return	FALSE ;

	if (! bExtended) {
		if (uKeyMask != 0 || nKeyCode < 0 || nKeyCode >= MAX_KEYBINDS)
			return	FALSE ;
		pKeymap->m_rbyBaseMap [nKeyCode]	= nKeyFunction ;
	} else {
		pKeyBind	= pKeymap->m_pKeyBinds ;
		for (i = 0 ; i < pKeymap->m_nKeyBinds ; i ++) {
			if (pKeyBind->m_nKeyCode == nKeyCode && pKeyBind->m_uKeyMask == uKeyMask) {
				/* found */
				pKeyBind->m_nKeyFunction	= nKeyFunction ;
				return	TRUE ;
			}
			pKeyBind	++ ;
		}

		pNewKeyBind	= new CImeKeyBind [pKeymap->m_nKeyBinds + 1] ;
		if (pNewKeyBind == NULL)
			return	FALSE ;
		if (pKeymap->m_nKeyBinds > 0)
			memcpy (pNewKeyBind, pKeymap->m_pKeyBinds, sizeof (struct CImeKeyBind) * pKeymap->m_nKeyBinds) ;
		if (pKeymap->m_pKeyBinds != NULL)
			delete[]	pKeymap->m_pKeyBinds ;
		pKeymap->m_pKeyBinds	= pNewKeyBind ;
		pNewKeyBind [pKeymap->m_nKeyBinds].m_nKeyCode	= nKeyCode ;
		pNewKeyBind [pKeymap->m_nKeyBinds].m_uKeyMask	= uKeyMask ;
		pNewKeyBind [pKeymap->m_nKeyBinds].m_nKeyFunction	= nKeyFunction ;
		pKeymap->m_nKeyBinds	++ ;
	}
	return	TRUE ;
}

/*========================================================================
 *	private functions (for Keybind/[}ȃ[)
 */
static	BOOL	imeConfig_bLoadRomaKanaRuleListFromRegistry (void) ;
static	BOOL	imeConfig_bInitializeDefaultRomaKanaRuleTree (CSkkRuleTreeNode** ppRoot) ;

BOOL
imeConfig_bLoadRomaKanaRuleList (void)
{
	BOOL	bRetval ;

	_pOhOutput		= NULL ;
	_pSkkRuleTree	= NULL ;

	bRetval	= imeConfig_bLoadRomaKanaRuleListFromRegistry () ;
	if (! bRetval || _siRomaKanaRuleListType == KEYBINDTP_DEFAULT) {
		_siRomaKanaRuleListType	= KEYBINDTP_DEFAULT ;
		imeConfig_bInitializeDefaultRomaKanaRuleTree (&_pSkkRuleTree) ;
	}
	if (! bRetval || _bOHHenkan) {
		_bOHHenkan	= TRUE ;
		_pOhOutput	= CSkkRuleTreeNodeOutputStringPair::pCreateInstance (L"", 1, L"I", 1) ;
	}
	return	TRUE ;
}

void
imeConfig_vClearRomaKanaRuleList (void)
{
	CSkkRuleTreeNode::vDestroyTree (_pSkkRuleTree) ;
	_pSkkRuleTree	= NULL ;

	if (_pOhOutput != NULL) {
		delete	_pOhOutput ;
		_pOhOutput	= NULL ;
	}
	return ;
}

BOOL
imeConfig_bLoadRomaKanaRuleListFromRegistry (void)
{
	HKEY	hSubKey ;
	LPWSTR	pwData	= NULL ;
	LPCWSTR	pwSrc ;
	WCHAR	bufState [128], bufNext [128], bufHira [128], bufKata [128] ;
	BOOL	bExistUserDefinedRomaKanaRule	= FALSE ;
	CSkkRuleTreeNode*	pSkkRuleTreeRoot ;
	BOOL	bRetval	= TRUE ;

	pSkkRuleTreeRoot				= NULL ;
	if (RegOpenKeyExW (HKEY_CURRENT_USER, REGPATH_ROMAKANARULE, 0, KEY_READ, &hSubKey) == ERROR_SUCCESS) {
		LONG 	lResult ;
		DWORD	dwType, cbData, dwValue ;

		/* rule-list-type (default or custom) */
		cbData	= sizeof (dwValue) ;
		if (RegQueryValueExW (hSubKey, REGINFO_ROMAKANARULE_TYPE, NULL, &dwType, (BYTE*)&dwValue, &cbData) != ERROR_SUCCESS || dwType != REG_DWORD) {
			bRetval	= FALSE ;
			goto	skip_error ;
		}
		_siRomaKanaRuleListType	= (int) dwValue ;

		/* oh-henkan, rule-list-type  default Ȃ瑶݂ȂƂ̂ŁA̓G[ł͂ȂB*/
		cbData	= sizeof (dwValue) ;
		dwValue	= 0 ;
		if (RegQueryValueExW (hSubKey, REGINFO_ENABLEOHHENKAN, NULL, &dwType, (BYTE*)&dwValue, &cbData) != ERROR_SUCCESS) {
			_bOHHenkan	= ENABLE_OHHENKAN_DEFAULT_VALUE ;	/* default value */
		} else {
			if (dwType != REG_DWORD) {
				bRetval	= FALSE ;
				goto	skip_error ;
			}
			_bOHHenkan	= (dwValue != 0) ;
			bExistUserDefinedRomaKanaRule	= TRUE ;
		}

		if (_siRomaKanaRuleListType != KEYBINDTP_DEFAULT) {
			/* roma-kana-rule {́B*/
			lResult	= RegQueryValueExW (hSubKey, REGINFO_ROMAKANARULE, NULL, &dwType, NULL, &cbData) ;
			if (lResult != ERROR_SUCCESS) 
				goto	skip_error ;
			if (dwType != REG_MULTI_SZ) {
				bRetval	= FALSE ;
				goto	skip_error ;
			}
			pwData	= (LPWSTR) new WCHAR [cbData] ;
			if (pwData == NULL)
				goto	skip_error ;

			(void) RegQueryValueExW (hSubKey, REGINFO_ROMAKANARULE, NULL, &dwType, (BYTE*)pwData, &cbData) ;
		}
		bExistUserDefinedRomaKanaRule	= TRUE ;
skip_error:
		RegCloseKey (hSubKey) ;
	}
	if (! bRetval)
		goto	error_exit ;

	if (pwData != NULL) {
		pwSrc	= pwData ;
		while (*pwSrc != L'\0') {
			int							nType ;
			BOOL						bTerminated ;
			LPCWSTR						pwNext ;

			nType	= *pwSrc ++ ;
			if (! imeConfig_bParseBSEncodedString (&pwSrc, bufState, MYARRAYSIZE (bufState) - 1, &bTerminated) || bTerminated)
				goto	error_exit ;
			if (! imeConfig_bParseBSEncodedString (&pwSrc, bufNext,  MYARRAYSIZE (bufNext)  - 1, &bTerminated) || bTerminated)
				goto	error_exit ;
			bufState [MYARRAYSIZE (bufState) - 1]	= L'\0' ;
			bufNext  [MYARRAYSIZE (bufNext)  - 1]	= L'\0' ;
			pwNext	= (bufNext [0] != L'\0')? bufNext : NULL ;

			switch (nType) {
			case	TEXT ('1'):
				if (! imeConfig_bParseBSEncodedString (&pwSrc, bufHira, MYARRAYSIZE (bufHira) - 1, &bTerminated) || bTerminated)
					goto	error_exit ;
				if (! imeConfig_bParseBSEncodedString (&pwSrc, bufKata, MYARRAYSIZE (bufKata) - 1, &bTerminated) || ! bTerminated)
					goto	error_exit ;

				bufHira [MYARRAYSIZE (bufHira) - 1]	= L'\0' ;
				bufKata [MYARRAYSIZE (bufKata)  - 1]	= L'\0' ;
				if (! CSkkRuleTreeNode::bAddRule (&pSkkRuleTreeRoot, bufState, lstrlenW (bufState), pwNext, lstrlenW (bufNext), bufHira, lstrlenW (bufHira), bufKata, lstrlenW (bufKata))) {
					goto	error_exit ;
				}
				break ;
			case	TEXT ('2'):
				if (! imeConfig_bParseBSEncodedString (&pwSrc, bufHira, MYARRAYSIZE (bufHira) - 1, &bTerminated) || ! bTerminated)
					goto	error_exit ;
				bufHira [MYARRAYSIZE (bufHira) - 1]	= L'\0' ;
				if (! CSkkRuleTreeNode::bAddRule (&pSkkRuleTreeRoot, bufState, lstrlenW (bufState), pwNext, lstrlenW (bufNext), bufHira, lstrlenW (bufHira))) {
					goto	error_exit ;
				}
				break ;
			case	TEXT ('3'):
				{
					LPCWSTR	pwTemp ;
					int		nFuncNo	= 0 ;

					if (! imeConfig_bParseBSEncodedString (&pwSrc, bufHira, MYARRAYSIZE (bufHira) - 1, &bTerminated) || ! bTerminated)
						goto	error_exit ;
					bufHira [MYARRAYSIZE (bufHira) - 1]	= L'\0' ;

					pwTemp	= bufHira ;
					while (*pwTemp != L'\0') {
						int		nCH	; 
						nCH	= *pwTemp ++ ;
						if (L'0' <= nCH && nCH <= L'9') {
							nFuncNo	= nFuncNo * 10 + (nCH - L'0') ;
						} else {
							goto	error_exit ;
						}
					}
					if (! CSkkRuleTreeNode::bAddRule (&pSkkRuleTreeRoot, bufState, lstrlenW (bufState), pwNext, lstrlenW (bufNext), nFuncNo)) {
						goto	error_exit ;
					}
				}
				break ;
			default:
				goto	error_exit ;
			}
			pwSrc	++ ;	/* nul  skip */
		}
		delete[]	pwData ;
	}
	_pSkkRuleTree	= pSkkRuleTreeRoot ;
	return	TRUE ;

error_exit:
	CSkkRuleTreeNode::vDestroyTree (pSkkRuleTreeRoot) ;
	delete[]	pwData ;
	return	FALSE ;
}

void
imeConfig_vClearKeymaps (void)
{
	imeConfig_vClearKeymap (&_sMajorModeMap) ;
	imeConfig_vClearKeymap (&_sSkkJModeMap) ;
	imeConfig_vClearKeymap (&_sSkkLatinModeMap) ;
	imeConfig_vClearKeymap (&_sSkkJisx0208LatinModeMap) ;
	imeConfig_vClearKeymap (&_sSkkAbbrevModeMap) ;
	imeConfig_vClearKeymap (&_sMinibufferMinorModeMap) ;
	return ;
}

void
imeConfig_vClearKeymap (struct CImeKeymap* pKeymap) 
{
	if (pKeymap == NULL)
		return ;
	if (pKeymap->m_nKeyBinds > 0 && pKeymap->m_pKeyBinds != NULL) 
		delete[]	pKeymap->m_pKeyBinds ;
	pKeymap->m_pKeyBinds	= NULL ;
	pKeymap->m_nKeyBinds	= 0 ;
	return ;
}

/*========================================================================
 *	private functions (for Keybind)
 */
static	BOOL	imeConfig_bLoadGenericSettingFromRegistry (void) ;

BOOL
imeConfig_bLoadGenericSetting (void)
{
	static const struct {
		LPCWSTR		m_strLeft ;
		LPCWSTR		m_strRight ;
	}	_srDefaultBracketParens []	= {
		{ L"u",	L"v" },	{ L"w",	L"x" },
		{ L"(",		L")"  },	{ L"i",	L"j" }, 
		{ L"{",		L"}"  },	{ L"o",	L"p" },
		{ L"q",	L"r" },	{ L"s",	L"t" },
		{ L"[",		L"]"  },	{ L"m",	L"n" },
		{ L"k",	L"l" },	{ L"y",	L"z" }, 
		{ L"\"",	L"\"" },	{ L"g",	L"h" },
		{ L"`",		L"'"  }, 
	},	_srDefaultKutoutens []	= {
		{ L"C",	L"D"	},	{ L"A",	L"B" },
	} ;
	int	i ;

	if (! imeConfig_bLoadGenericSettingFromRegistry ()) {
		/* default setting */
		_bKanaModeWhenOpen		= TRUE ;
		_bEcho					= TRUE ;
		_bAutoInsertParen		= TRUE ;
		_bCompositionAutoShift	= TRUE ;
		_bDeleteImpliesKakutei	= TRUE ;
		_bDateAd				= FALSE ;
		_iNumberStyle			= 0 ;
		_iKutoutenType			= KUTOUTEN_TYPE_JP ;

		for (i = 0 ; i < MYARRAYSIZE (_srDefaultBracketParens) ; i ++) {
			lstrcpynW (_srBracketParen [i].m_bufLeft,  _srDefaultBracketParens [i].m_strLeft,  MYARRAYSIZE (_srBracketParen [i].m_bufLeft)) ;
			lstrcpynW (_srBracketParen [i].m_bufRight, _srDefaultBracketParens [i].m_strRight, MYARRAYSIZE (_srBracketParen [i].m_bufRight)) ;
		}
		_iNumBracketParen		= MYARRAYSIZE (_srDefaultBracketParens) ;
	}
	switch (_iKutoutenType) {
	case	KUTOUTEN_TYPE_EN:
		lstrcpynW (_srKutouten [0].m_bufLeft,  _srDefaultKutoutens [0].m_strLeft,  MYARRAYSIZE (_srKutouten [0].m_bufLeft)) ;
		lstrcpynW (_srKutouten [0].m_bufRight, _srDefaultKutoutens [0].m_strRight, MYARRAYSIZE (_srKutouten [0].m_bufRight)) ;
		lstrcpynW (_srKutouten [1].m_bufLeft,  _srDefaultKutoutens [1].m_strLeft,  MYARRAYSIZE (_srKutouten [1].m_bufLeft)) ;
		lstrcpynW (_srKutouten [1].m_bufRight, _srDefaultKutoutens [1].m_strRight, MYARRAYSIZE (_srKutouten [1].m_bufRight)) ;
		_iNumKutouten			= 2 ;
		break; 
	case	KUTOUTEN_TYPE_JP:
		lstrcpynW (_srKutouten [1].m_bufLeft,  _srDefaultKutoutens [0].m_strLeft,  MYARRAYSIZE (_srKutouten [0].m_bufLeft)) ;
		lstrcpynW (_srKutouten [1].m_bufRight, _srDefaultKutoutens [0].m_strRight, MYARRAYSIZE (_srKutouten [0].m_bufRight)) ;
		lstrcpynW (_srKutouten [0].m_bufLeft,  _srDefaultKutoutens [1].m_strLeft,  MYARRAYSIZE (_srKutouten [1].m_bufLeft)) ;
		lstrcpynW (_srKutouten [0].m_bufRight, _srDefaultKutoutens [1].m_strRight, MYARRAYSIZE (_srKutouten [1].m_bufRight)) ;
		_iNumKutouten			= 2 ;
		break; 
	default:
		break; 
	}
	return	TRUE ;
}

BOOL
imeConfig_bLoadGenericSettingFromRegistry (void)
{
	static	const struct {
		LPCWSTR		m_strKeyInfo ;
		int			m_iType ;
		void*		m_pvData ;
	}	_srRegValues [10]	= {
		{	REGINFO_KANAMODEWHENOPEN,		REGKEYTYPE_BOOL,	&_bKanaModeWhenOpen,	},
		{	REGINFO_ECHO,					REGKEYTYPE_BOOL,	&_bEcho,	},
		{	REGINFO_COMPOSITIONAUTOSHIFT,	REGKEYTYPE_BOOL,	&_bCompositionAutoShift,	},
		{	REGINFO_DELETEIMPLIESKAKUTEI,	REGKEYTYPE_BOOL,	&_bDeleteImpliesKakutei,	},
		{	REGINFO_DATEAD,					REGKEYTYPE_INT,		&_bDateAd,	},
		{	REGINFO_NUMBERSTYLE,			REGKEYTYPE_INT,		&_iNumberStyle,	},
		{	REGINFO_KAKUTEIEARLY,			REGKEYTYPE_BOOL,	&_bKakuteiEarly,	},
		{	REGINFO_KUTOUTENTYPE,			REGKEYTYPE_INT,		&_iKutoutenType,	},
		{	REGINFO_AUTOINSERTPAREN,		REGKEYTYPE_INT,		&_iBracketParenType,	},
		{	REGINFO_OKURICHARALISTTYPE,		REGKEYTYPE_INT,		&_iOkuriCharAlistType,	},
	} ;
	HKEY	hSubKey ;
	LONG 	lResult ;
	DWORD	dwType, cbData ;
	int		i ;
	LPWSTR	pwBracketParen		= NULL ;
	LPWSTR	pwKutoutens			= NULL ;
	LPWSTR	pwOkuriCharAlist	= NULL ;
	BOOL	bRetval				= FALSE ;

	if (RegOpenKeyExW (HKEY_CURRENT_USER, REGPATH_GENERIC, 0, KEY_READ, &hSubKey) != ERROR_SUCCESS) 
		return	FALSE ;

	for (i = 0 ; i < MYARRAYSIZE (_srRegValues) ; i ++) {
		DWORD	dwValue ;

		cbData	= sizeof (DWORD) ;
		lResult	= RegQueryValueExW (hSubKey, _srRegValues [i].m_strKeyInfo, NULL, &dwType, (BYTE*)&dwValue, &cbData) ;
		if (lResult != ERROR_SUCCESS || dwType != REG_DWORD)
			goto	skip_error ;
		switch (_srRegValues [i].m_iType) {
		case	REGKEYTYPE_BOOL:
			*(BOOL*)(_srRegValues [i].m_pvData)	= (dwValue != 0) ;
			break ;
		case	REGKEYTYPE_INT:
			*(int*)(_srRegValues [i].m_pvData)	= (int)dwValue ;
			break ;
		default:
			break ;
		}
	}

	/*	ʃyAݒ̓ǂݍ݁B*/
	cbData	= 0 ;
	lResult	= RegQueryValueExW (hSubKey, REGINFO_BRACKETPARENS, NULL, &dwType, NULL, &cbData) ;
	if (lResult == ERROR_SUCCESS) {
		if (dwType != REG_MULTI_SZ)
			goto	skip_error ;
		pwBracketParen	= (LPWSTR) new WCHAR [cbData] ;
		if (pwBracketParen == NULL)
			goto	skip_error ;
		(void) RegQueryValueExW (hSubKey, REGINFO_BRACKETPARENS, NULL, &dwType, (BYTE*)pwBracketParen, &cbData) ;
	} else {
		_iBracketParenType		= BRACKETPARENTP_DEFAULT ;
	}

	/*	Ǔ_ݒ̓ǂݍ݁B*/
	cbData	= 0 ;
	lResult	= RegQueryValueExW (hSubKey, REGINFO_KUTOUTENS, NULL, &dwType, NULL, &cbData) ;
	if (lResult == ERROR_SUCCESS) {
		if (dwType != REG_MULTI_SZ)
			goto	skip_error ;
		pwKutoutens	= (LPWSTR) new WCHAR [cbData] ;
		if (pwKutoutens == NULL)
			goto	skip_error ;
		(void) RegQueryValueExW (hSubKey, REGINFO_KUTOUTENS, NULL, &dwType, (BYTE*)pwKutoutens, &cbData) ;
	} else {
		_iKutoutenType			= KUTOUTEN_TYPE_JP ;
	}

	/*	艼ǂݑւݒ̓ǂݍ݁B*/
	cbData	= 0 ;
	lResult	= RegQueryValueExW (hSubKey, REGINFO_OKURICHARALIST, NULL, &dwType, NULL, &cbData) ;
	if (lResult == ERROR_SUCCESS) {
		if (dwType != REG_MULTI_SZ)
			goto	skip_error ;
		pwOkuriCharAlist	= (LPWSTR) new WCHAR [cbData] ;
		if (pwOkuriCharAlist == NULL)
			goto	skip_error ;
		(void) RegQueryValueExW (hSubKey, REGINFO_OKURICHARALIST, NULL, &dwType, (BYTE*)pwOkuriCharAlist, &cbData) ;
	} else {
		_iOkuriCharAlistType	= OKURICHARTP_DEFAULT ;
	}
	bRetval	= TRUE ;

skip_error:
	RegCloseKey (hSubKey) ;

	/* BracketParen  parse */
	if (bRetval && pwBracketParen != NULL) {
		_iNumBracketParen	= imeConfig_iDecodeStringPairList (pwBracketParen, _srBracketParen, MYARRAYSIZE (_srBracketParen)) ;
	}
	/* Kutouten  parse */
	if (bRetval && pwKutoutens != NULL) {
		_iNumKutouten	= imeConfig_iDecodeStringPairList (pwKutoutens, _srKutouten, MYARRAYSIZE (_srKutouten)) ;
	}
	if (bRetval && pwOkuriCharAlist != NULL) {
		_iNumOkuriCharAlist	= imeConfig_iDecodeStringPairList (pwKutoutens, _srOkuriCharAlist, MYARRAYSIZE (_srOkuriCharAlist)) ;
	}
	if (pwBracketParen != NULL)
		delete[]	pwBracketParen ;
	if (pwKutoutens != NULL)
		delete[]	pwKutoutens ;
	if (pwOkuriCharAlist != NULL)
		delete[]	pwOkuriCharAlist ;
	return	bRetval ;
}

/*========================================================================
 *	private functions for conversion
 */
static	BOOL	imeConfig_bLoadConversionSettingFromRegistry (void) ;

BOOL
imeConfig_bLoadConversionSetting (void)
{
	static	const WCHAR	_srbDefaultCandidateKeys []	= {
		'A', 'S', 'D', 'F', 'J', 'K', 'L', 'Q', 'W', 'U', 'I', 'O', 'Z', 'C', 'V', 'B', 'M', 
	} ;
	static	const WCHAR	_srbDefaultMenu1Keys []	= {
		'A', 'S', 'D', 'F', 'G', 'H', 'Q', 'W', 'E', 'R', 'T', 'Y',
	} ;
	static	const WCHAR	_srbDefaultMenu2Keys []	= {
		'A', 'S', 'D', 'F', 'G', 'H', 'J', 'K', 'L', 'Q', 'W', 'E', 'R', 'T', 'Y', 'U',
	} ;
	static	const WCHAR	_srb10Keys []	= {
		'1', '2', '3', '4', '5', '6', '7', '8', '9', '0', 
	} ;
	/* 28 keywords */
	static	const WCHAR	_srDefaultAutoStartHenkanKeywords []	= L"\0A\0B\0D\0C\0H\0v\0I\0G\0F\0)\0;\0:\0j\0h\0z\0x\0t\0r\0p\0nl\0}\0]\0?\0.\0,\0!\0\0" ;

	if (! imeConfig_bLoadConversionSettingFromRegistry ()) {
		_snCandListKeyAssign			= CANDLIST_KEYASSIGN_DEFAULT ;
		_snNumShowCandidateKeys			= 0 ;
		_snNumInputCodeMenu1Keys		= 0 ;
		_snNumInputCodeMenu2Keys		= 0 ;

		_snShowCandListCount			= SHOWCANDLIST_COUNT_ZERO+3 ;
		_sbHenkanOkuriStrictly			= FALSE ;
		_sbProcessOkuriEarly			= FALSE ;
		_sbHenkanStrictOkuriPrecedence	= FALSE ;
		_sbAutoStartHenkan				= TRUE ;
		_sbDeleteOkuriWhenQuit			= FALSE ;
		_sbAutoOkuriProcess				= FALSE ;
		_snShowAnnotationType			= SHOW_NO_ANNOTATION ;
		_siNumAutoStartHenkanKeywords	= -1 ;
	}
	switch (_snCandListKeyAssign) {
	case	CANDLIST_KEYASSIGN_DEFAULT:
		_snNumShowCandidateKeys		= MYARRAYSIZE (_srbDefaultCandidateKeys) ;
		_snNumInputCodeMenu1Keys	= MYARRAYSIZE (_srbDefaultMenu1Keys) ;
		_snNumInputCodeMenu2Keys	= MYARRAYSIZE (_srbDefaultMenu2Keys) ;
		memcpy (_srwchShowCandidateKeys,	_srbDefaultCandidateKeys,	sizeof (_srbDefaultCandidateKeys)) ;
		memcpy (_srwchInputCodeMenu1Keys,	_srbDefaultMenu1Keys,		sizeof (_srbDefaultMenu1Keys)) ;
		memcpy (_srwchInputCodeMenu2Keys,	_srbDefaultMenu2Keys,		sizeof (_srbDefaultMenu2Keys)) ;
		break ;
	case	CANDLIST_KEYASSIGN_01234567890:
		_snNumShowCandidateKeys		= MYARRAYSIZE (_srb10Keys) ;
		_snNumInputCodeMenu1Keys	= MYARRAYSIZE (_srb10Keys) ;
		_snNumInputCodeMenu2Keys	= MYARRAYSIZE (_srb10Keys) ;
		memcpy (_srwchShowCandidateKeys,	_srb10Keys, sizeof (_srb10Keys)) ;
		memcpy (_srwchInputCodeMenu1Keys,	_srb10Keys, sizeof (_srb10Keys)) ;
		memcpy (_srwchInputCodeMenu2Keys,	_srb10Keys, sizeof (_srb10Keys)) ;
		break ;
	default:
		break; 
	}
	if (_siNumAutoStartHenkanKeywords < 0) {
		_siNumAutoStartHenkanKeywords	= 28 ;
		memcpy (_srAutoStartHenkanKeywords, _srDefaultAutoStartHenkanKeywords, sizeof (_srDefaultAutoStartHenkanKeywords)) ;
	}
	return	TRUE ;
}

BOOL
imeConfig_bLoadConversionSettingFromRegistry (void)
{
	static struct {
		LPCWSTR		m_strInfoKey ;
		BOOL*		m_pbData ;
	}	_srRegBoolValues []	= {
		{	REGINFO_HENKANOKURISTRICTLY,			&_sbHenkanOkuriStrictly,	},
		{	REGINFO_PROCESSOKURIEARLY,				&_sbProcessOkuriEarly,	},
		{	REGINFO_HENKANSTRICTOKURIPRECEDENCE,	&_sbHenkanStrictOkuriPrecedence,	},
		{	REGINFO_AUTOSTARTHENKAN,				&_sbAutoStartHenkan,	},
		{	REGINFO_DELETEOKURIWHENQUIT,			&_sbDeleteOkuriWhenQuit,	},
		{	REGINFO_AUTOOKURIPROCESS,				&_sbAutoOkuriProcess,	},
	} ;
	HKEY	hSubKey ;
	LONG 	lResult ;
	DWORD	dwType, cbData, dwValue ;
	int		i ;
	BYTE	rbBuffer [MAX_NUMMENUKEYS] ;
	BOOL	bRetval	= FALSE ;

	if (RegOpenKeyExW (HKEY_CURRENT_USER, REGPATH_CONVERSION, 0, KEY_READ, &hSubKey) != ERROR_SUCCESS) 
		return	FALSE ;

	cbData	= sizeof (DWORD) ;
	lResult	= RegQueryValueExW (hSubKey, REGINFO_CANDLISTKEYASSIGN, NULL, &dwType, (BYTE*)&dwValue, &cbData) ;
	if (lResult != ERROR_SUCCESS || dwType != REG_DWORD)
		goto	skip_error ;
	_snCandListKeyAssign	= (/*CANDLIST_KEYASSIGN_DEFAULT <= dwValue && */dwValue <= CANDLIST_KEYASSIGN_01234567890)? (int) dwValue : CANDLIST_KEYASSIGN_USERDEFINED ;

	cbData	= sizeof (DWORD) ;
	lResult	= RegQueryValueExW (hSubKey, REGINFO_SHOWCANDIDATELISTCOUNT, NULL, &dwType, (BYTE*)&dwValue, &cbData) ;
	if (lResult != ERROR_SUCCESS || dwType != REG_DWORD)
		goto	skip_error ;
	_snShowCandListCount	= (int) dwValue ;


	for (i = 0 ; i < MYARRAYSIZE (_srRegBoolValues) ; i ++) {
		cbData	= sizeof (DWORD) ;
		lResult	= RegQueryValueExW (hSubKey, _srRegBoolValues [i].m_strInfoKey, NULL, &dwType, (BYTE*)&dwValue, &cbData) ;
		if (lResult != ERROR_SUCCESS || dwType != REG_DWORD)
			goto	skip_error ;
		*(BOOL*)(_srRegBoolValues [i].m_pbData)	= (dwValue != 0) ;
	}

	cbData	= 0 ;
	lResult	= RegQueryValueExW (hSubKey, REGINFO_SHOWCANDIDATEKEYS, NULL, &dwType, NULL, &cbData) ;
	if (lResult != ERROR_SUCCESS || dwType != REG_BINARY || cbData <= 0 || cbData >= MAX_NUMMENUKEYS) {
		if (_snCandListKeyAssign == CANDLIST_KEYASSIGN_USERDEFINED)
			_snCandListKeyAssign	= CANDLIST_KEYASSIGN_DEFAULT ;
		_snNumShowCandidateKeys	= 0 ;
	} else {
		(void) RegQueryValueExW (hSubKey, REGINFO_SHOWCANDIDATEKEYS, NULL, &dwType, (BYTE*)rbBuffer, &cbData) ;
		for (i = 0 ; i < (int) cbData ; i ++) 
			_srwchShowCandidateKeys [i]	= (WCHAR) rbBuffer [i] ;
		_snNumShowCandidateKeys	= (int) cbData ;
	}

	cbData	= 0 ;
	lResult	= RegQueryValueExW (hSubKey, REGINFO_INPUTCODEMENU1KEYS, NULL, &dwType, NULL, &cbData) ;
	if (lResult != ERROR_SUCCESS || dwType != REG_BINARY || cbData <= 0 || cbData >= MAX_NUMMENUKEYS) {
		if (_snCandListKeyAssign == CANDLIST_KEYASSIGN_USERDEFINED)
			_snCandListKeyAssign	= CANDLIST_KEYASSIGN_DEFAULT ;
		_snNumInputCodeMenu1Keys	= 0 ;
	} else {
		(void) RegQueryValueExW (hSubKey, REGINFO_INPUTCODEMENU1KEYS, NULL, &dwType, (BYTE*)rbBuffer, &cbData) ;
		for (i = 0 ; i < (int) cbData ; i ++) 
			_srwchInputCodeMenu1Keys [i]	= (WCHAR) rbBuffer [i] ;
		_snNumInputCodeMenu1Keys	= (int) cbData ;
	}

	cbData	= 0 ;
	lResult	= RegQueryValueExW (hSubKey, REGINFO_INPUTCODEMENU2KEYS, NULL, &dwType, NULL, &cbData) ;
	if (lResult != ERROR_SUCCESS || dwType != REG_BINARY || cbData <= 0 || cbData >= MAX_NUMMENUKEYS) {
		if (_snCandListKeyAssign == CANDLIST_KEYASSIGN_USERDEFINED)
			_snCandListKeyAssign	= CANDLIST_KEYASSIGN_DEFAULT ;
		_snNumInputCodeMenu2Keys	= 0 ;
	} else {
		(void) RegQueryValueExW (hSubKey, REGINFO_INPUTCODEMENU2KEYS, NULL, &dwType, (BYTE*)rbBuffer, &cbData) ;
		for (i = 0 ; i < (int) cbData ; i ++) 
			_srwchInputCodeMenu2Keys [i]	= (WCHAR) rbBuffer [i] ;
		_snNumInputCodeMenu2Keys	= (int) cbData ;
	}

	cbData	= 0 ;
	lResult	= RegQueryValueExW (hSubKey, REGINFO_AUTOSTARTHENKANKEYWORD, NULL, &dwType, NULL, &cbData) ;
	if (lResult != ERROR_SUCCESS || dwType != REG_MULTI_SZ || cbData <= 0 || cbData >= sizeof (_srAutoStartHenkanKeywords)) {
		/* default ̐ݒB*/
		_siNumAutoStartHenkanKeywords	= -1 ;
	} else {
		LPCWSTR	pSrc, pSrcLast ;
		int		iNumKeywords ;

		(void) RegQueryValueExW (hSubKey, REGINFO_AUTOSTARTHENKANKEYWORD, NULL, &dwType, (BYTE*) _srAutoStartHenkanKeywords, &cbData) ;
		/* 𐔂B*/
		iNumKeywords	= 0 ;
		pSrc			= _srAutoStartHenkanKeywords ;
		pSrcLast		= _srAutoStartHenkanKeywords + MYARRAYSIZE (_srAutoStartHenkanKeywords) ;
		while (pSrc < pSrcLast && *pSrc != TEXT ('\0')) {
			int	nKeywordLen	= lstrlenW (pSrc) ;
			if (nKeywordLen > 0)
				iNumKeywords ++ ;
			pSrc	+= nKeywordLen + 1 ;
		}
		_siNumAutoStartHenkanKeywords	= iNumKeywords ;
	}

	cbData	= 0 ;
	lResult	= RegQueryValueExW (hSubKey, REGINFO_SHOWANNOTATIONTYPE, NULL, &dwType, NULL, &cbData) ;
	if (lResult != ERROR_SUCCESS || dwType != REG_DWORD) {
		_snShowAnnotationType	= SHOW_NO_ANNOTATION ;
	} else {
		DWORD	dwValue ;
		(void) RegQueryValueExW (hSubKey, REGINFO_SHOWANNOTATIONTYPE, NULL, &dwType, (BYTE*)&dwValue, &cbData) ;

		if (dwValue == (DWORD)DISABLE_ANNOTATION) {
			_snShowAnnotationType	= DISABLE_ANNOTATION ;
		} else if (0 <= dwValue && dwValue <= SHOW_ANNOTATION_ALWAYS) {
			_snShowAnnotationType	= (int) dwValue ;
		} else {
			_snShowAnnotationType	= SHOW_NO_ANNOTATION ;
		}
	}
	bRetval	= TRUE ;

skip_error:
	RegCloseKey (hSubKey) ;
	return	bRetval ;
}

/*========================================================================
 *	private functions for colorface
 */
static	BOOL	imeConfig_bLoadColorfaceSettingFromRegistry (const MYCOLORFACESET*) ;
static	BOOL	bIsValidColor		(int) ;
static	BOOL	bIsValidLineType	(int) ;

BOOL
imeConfig_bLoadColorfaceSetting (void)
{
	static	const MYCOLORFACESET		_srDefaultColorFaces []	= {
		/*	ϊB*/
		{ MYCOLOR_TEXTAUTO,			/* () */	/* FB*/
		  MYCOLOR_BACKAUTO,			/* (wi) */ 	/* wiFB*/
		  MYCOLOR_TEXTAUTO,			/* () */	/* FB*/
		  MYLINE_THIN_DITHER,		/* fBU() */	/* ^CvB*/
		},
		/*	ϊB*/
		{ MYCOLOR_HIGHLIGHTTEXT,	/* I() */	/* FB*/
		  MYCOLOR_HIGHLIGHT,		/* I(wi) */	/* wiFB*/
		  MYCOLOR_TEXTAUTO,			/* () */	 	/* FB*/
		  MYLINE_NO,				/* Ȃ */				/* ^CvB*/
		},
	} ;

	if (! imeConfig_bLoadColorfaceSettingFromRegistry (_srDefaultColorFaces)) 
		memcpy (_srImeColorFaces, _srDefaultColorFaces, sizeof (_srImeColorFaces)) ;
	return	TRUE ; 
}

BOOL
imeConfig_bLoadColorfaceSettingFromRegistry (
	const MYCOLORFACESET*	pDefaultColorFaces)
{
	HKEY	hSubKey ;
	BOOL	bRetval	= FALSE ;
	BYTE	rbStyles [MYARRAYSIZE (_srImeColorFaces) * 4] ;
	int		i ;

	if (RegOpenKeyExW (HKEY_CURRENT_USER, REGPATH_COLORFACE, 0, KEY_READ, &hSubKey) == ERROR_SUCCESS) {
		LONG 		lResult ;
		DWORD		dwType, cbData ;
		const BYTE*	pbData ;

		lResult	= RegQueryValueExW (hSubKey, REGSUBKEY_COLORFACE, NULL, &dwType, NULL, &cbData) ;
		if (lResult != ERROR_SUCCESS || dwType != REG_BINARY || cbData != sizeof (rbStyles))
			goto	skip_error ;

		(void) RegQueryValueExW (hSubKey, REGSUBKEY_COLORFACE, NULL, &dwType, (BYTE*)rbStyles, &cbData) ;

		pbData	= rbStyles ;
		for (i = 0 ; i < MYARRAYSIZE (_srImeColorFaces) ; i ++) {
			int		nTextColor, nBackColor, nUnderLineColor, nUnderLineType ;

			nTextColor		= *pbData ++ ;
			nTextColor		= bIsValidColor (nTextColor)? nTextColor : pDefaultColorFaces [i].m_nTextColor ;
			_srImeColorFaces [i].m_nTextColor		= nTextColor ;	
			nBackColor		= *pbData ++ ;
			nBackColor		= bIsValidColor (nBackColor)? nBackColor : pDefaultColorFaces [i].m_nBackColor ;
			_srImeColorFaces [i].m_nBackColor		= nBackColor ;
			nUnderLineColor	= *pbData ++ ;
			nUnderLineColor	= bIsValidColor (nUnderLineColor)? nUnderLineColor : pDefaultColorFaces [i].m_nUnderLineColor ;
			_srImeColorFaces [i].m_nUnderLineColor	= nUnderLineColor ;
			nUnderLineType	= *pbData ++ ;
			nUnderLineType	=  bIsValidLineType (nUnderLineType)? nUnderLineType : pDefaultColorFaces [i].m_nUnderLineType ;
			_srImeColorFaces [i].m_nUnderLineType	= nUnderLineType ;
		}
		bRetval		= TRUE ;
skip_error:
		RegCloseKey (hSubKey) ;
	}
	return	bRetval ;
}

BOOL
bIsValidColor (int nColorType)
{
	return	(nColorType < 0 || nColorType >= MAX_MYCOLOR) ? FALSE : TRUE ;
}

BOOL
bIsValidLineType (int nLineType)
{
	return	(nLineType < 0 || nLineType >= MAX_MYLINE)? FALSE : TRUE ;
}

/*
 */
BOOL
imeConfig_bParseBSEncodedString (
	LPCWSTR*	ppwSrc,
	LPWSTR		pwDest,
	int			nDestSize,
	BOOL*		pbTerminated)
{
	LPCWSTR	pwSrc ;
	LPWSTR	pwDestLast ;
	int		nCH ;

	pwSrc		= *ppwSrc ;
	pwDestLast	= pwDest + nDestSize ;
	while (*pwSrc != L'\0' && pwDest < pwDestLast) {
		if (*pwSrc == L'\\') {
			pwSrc	++ ;
			nCH		= *pwSrc ;
			if (nCH == L'\0') {
				break ;
			} else if (nCH == L'0') {
				/* I[B*/
				pwSrc ++ ;
				break ;
			} else {
				*pwDest ++	= nCH ;
			}
		} else {
			*pwDest ++	= *pwSrc ;
		}
		pwSrc	++ ;
	}
	if (pwDest < pwDestLast)
		*pwDest	= L'\0' ;
	*pbTerminated	= (*pwSrc == L'\0') ;
	*ppwSrc			= pwSrc ;
	return	TRUE ;
}

int
imeConfig_iDecodeStringPairList (
	LPCWSTR					pwEncodedString,
	struct TStringPair*		pDestBuffer,
	int						iBufferSize)
{
	struct TStringPair*		pDest ;
	struct TStringPair*		pDestEnd ;
	LPCWSTR	pwSrc ;
	WCHAR	bufLeft [BUFSIZE_STRPAIR], bufRight [BUFSIZE_STRPAIR] ;
	BOOL	bTerminated ;

	pwSrc			= pwEncodedString ;
	pDest			= pDestBuffer ;
	pDestEnd		= pDestBuffer + iBufferSize ;
	while (*pwSrc != L'\0' && pDest < pDestEnd) {
		if (! imeConfig_bParseBSEncodedString (&pwSrc, bufLeft, MYARRAYSIZE (bufLeft) - 1, &bTerminated) || bTerminated) {
			break ;
		}
		bufLeft [MYARRAYSIZE (bufLeft) - 1]	= L'\0' ;

		if (! imeConfig_bParseBSEncodedString (&pwSrc, bufRight, MYARRAYSIZE (bufRight) - 1, &bTerminated) || ! bTerminated) {
			break ;
		}
		bufRight [MYARRAYSIZE (bufRight) - 1]	= L'\0' ;

		lstrcpynW (pDest->m_bufLeft,  bufLeft,  MYARRAYSIZE (pDest->m_bufLeft)) ;
		lstrcpynW (pDest->m_bufRight, bufRight, MYARRAYSIZE (pDest->m_bufRight)) ;
		pDest	++ ;
	}
	return	pDest - pDestBuffer ;
}

/*========================================================================
 *	private functions for RuleTreeNode
 */
struct TSkkBaseRuleT1 {
	LPCWSTR	_strState ;
	LPCWSTR	_strNext ;
	struct {
		LPCWSTR	_strKata ;
		LPCWSTR	_strHira ;
	}	_case ;
} ;

struct TSkkBaseRuleT2 {
	LPCWSTR	_strState ;
	LPCWSTR	_strNext ;
	LPCWSTR	_strOutput ;
} ;

struct TSkkBaseRuleT3 {
	LPCWSTR	_strState ;
	LPCWSTR	_strNext ;
	int		_nFunction ;
} ;

static struct TSkkBaseRuleT1	_rT1 []	= {
	{ L"a",		NULL,	{ L"A",	L"" } },
	{ L"bb",	L"b",	{ L"b",	L"" } },		{ L"ba",	NULL,	{ L"o",	L"" } },
	{ L"be",	NULL,	{ L"x",	L"" } },		{ L"bi",	NULL,	{ L"r",	L"" } },
	{ L"bo",	NULL,	{ L"{",	L"" } },		{ L"bu",	NULL,	{ L"u",	L"" } },
    { L"bya",	NULL,	{ L"r",	L"т" } },	{ L"bye",	NULL,	{ L"rF",	L"т" } },
	{ L"byi",	NULL,	{ L"rB",	L"т" } },	{ L"byo",	NULL,	{ L"r",	L"т" } },
	{ L"byu",	NULL,	{ L"r",	L"т" } },
    { L"cc",	L"c",	{ L"b",	L"" } },		{ L"cha",	NULL,	{ L"`",	L"" } },
    { L"che",	NULL,	{ L"`F",	L"" } },	{ L"chi",	NULL,	{ L"`",	L"" } },
    { L"cho",	NULL,	{ L"`",	L"" } },	{ L"chu",	NULL,	{ L"`",	L"" } },
	{ L"cya",	NULL,	{ L"`",	L"" } },	{ L"cye",	NULL,	{ L"`F",	L"" } },
	{ L"cyi",	NULL,	{ L"`B",	L"" } },	{ L"cyo",	NULL,	{ L"`",	L"" } },
	{ L"cyu",	NULL,	{ L"`",	L"" } },	{ L"dd",	L"d",	{ L"b",	L"" } },
	{ L"da",	NULL,	{ L"_",	L"" } },		{ L"de",	NULL,	{ L"f",	L"" } },
	{ L"dha",	NULL,	{ L"f",	L"ł" } },	{ L"dhe",	NULL,	{ L"fF",	L"ł" } },
	{ L"dhi",	NULL,	{ L"fB",	L"ł" } },	{ L"dho",	NULL,	{ L"f",	L"ł" } },
	{ L"dhu",	NULL,	{ L"f",	L"ł" } },	{ L"di",	NULL,	{ L"a",	L"" } },
	{ L"do",	NULL,	{ L"h",	L"" } },		{ L"du",	NULL,	{ L"d",	L"" } },
	{ L"dya",	NULL,	{ L"a",	L"" } },	{ L"dye",	NULL,	{ L"aF",	L"" } },
	{ L"dyi",	NULL,	{ L"aB",	L"" } },	{ L"dyo",	NULL,	{ L"a",	L"" } },
	{ L"dyu",	NULL,	{ L"a",	L"" } },
	{ L"e",		NULL,	{ L"G",	L"" } },
	{ L"ff",	L"f",	{ L"b",	L"" } },		{ L"fa",	NULL,	{ L"t@",	L"ӂ" } },
	{ L"fe",	NULL,	{ L"tF",	L"ӂ" } },	{ L"fi",	NULL,	{ L"tB",	L"ӂ" } },
	{ L"fo",	NULL,	{ L"tH",	L"ӂ" } },	{ L"fu",	NULL,	{ L"t",	L"" } },
	{ L"fya",	NULL,	{ L"t",	L"ӂ" } },	{ L"fye",	NULL,	{ L"tF",	L"ӂ" } },
	{ L"fyi",	NULL,	{ L"tB",	L"ӂ" } },	{ L"fyo",	NULL,	{ L"t",	L"ӂ" } },
	{ L"fyu",	NULL,	{ L"t",	L"ӂ" } },
	{ L"gg",	L"g",	{ L"b",	L"" } },		{ L"ga",	NULL,	{ L"K",	L"" } },
	{ L"ge",	NULL,	{ L"Q",	L"" } },		{ L"gi",	NULL,	{ L"M",	L"" } },
	{ L"go",	NULL,	{ L"S",	L"" } },		{ L"gu",	NULL,	{ L"O",	L"" } },
	{ L"gya",	NULL,	{ L"M",	L"" } },	{ L"gye",	NULL,	{ L"MF",	L"" } },
	{ L"gyi",	NULL,	{ L"MB",	L"" } },	{ L"gyo",	NULL,	{ L"M",	L"" } },
	{ L"gyu",	NULL,	{ L"M",	L"" } },
	//{ L"h", L"", { L"I", L"" } },
	{ L"ha",	NULL,	{ L"n",	L"" } },		{ L"he",	NULL,	{ L"w",	L"" } },
	{ L"hi",	NULL,	{ L"q",	L"" } },		{ L"ho",	NULL,	{ L"z",	L"" } },
	{ L"hu",	NULL,	{ L"t",	L"" } },		{ L"hya",	NULL,	{ L"q",	L"Ђ" } },
	{ L"hye",	NULL,	{ L"qF",	L"Ђ" } },	{ L"hyi",	NULL,	{ L"qB",	L"Ђ" } },
	{ L"hyo",	NULL,	{ L"q",	L"Ђ" } },	{ L"hyu",	NULL,	{ L"q",	L"Ђ" } },
	{ L"i",		NULL,	{ L"C",	L"" } },		{ L"jj",	L"j",	{ L"b",	L"" } },
	{ L"ja",	NULL,	{ L"W",	L"" } },	{ L"je",	NULL,	{ L"WF",	L"" } },
	{ L"ji",	NULL,	{ L"W",	L"" } },		{ L"jo",	NULL,	{ L"W",	L"" } },
	{ L"ju",	NULL,	{ L"W",	L"" } },	{ L"jya",	NULL,	{ L"W",	L"" } },
	{ L"jye",	NULL,	{ L"WF",	L"" } },	{ L"jyi",	NULL,	{ L"WB",	L"" } },
	{ L"jyo",	NULL,	{ L"W",	L"" } },	{ L"jyu",	NULL,	{ L"W",	L"" } },
	{ L"kk",	L"k",	{ L"b",	L"" } },		{ L"ka",	NULL,	{ L"J",	L"" } },
	{ L"ke",	NULL,	{ L"P",	L"" } },		{ L"ki",	NULL,	{ L"L",	L"" } },
	{ L"ko",	NULL,	{ L"R",	L"" } },		{ L"ku",	NULL,	{ L"N",	L"" } },
	{ L"kya",	NULL,	{ L"L",	L"" } },	{ L"kye",	NULL,	{ L"LF",	L"" } },
	{ L"kyi",	NULL,	{ L"LB",	L"" } },	{ L"kyo",	NULL,	{ L"L",	L"" } },
	{ L"kyu",	NULL,	{ L"L",	L"" } },
	{ L"ma",	NULL,	{ L"}",	L"" } },		{ L"me",	NULL,	{ L"",	L"" } },
	{ L"mi",	NULL,	{ L"~",	L"" } },		{ L"mo",	NULL,	{ L"",	L"" } },
	{ L"mu",	NULL,	{ L"",	L"" } },		{ L"mya",	NULL,	{ L"~",	L"݂" } },
	{ L"mye",	NULL,	{ L"~F",	L"݂" } },	{ L"myi",	NULL,	{ L"~B",	L"݂" } },
	{ L"myo",	NULL,	{ L"~",	L"݂" } },	{ L"myu",	NULL,	{ L"~",	L"݂" } },
	{ L"n",		NULL,	{ L"",	L"" } },		{ L"n'",	NULL,	{ L"",	L"" } },
	{ L"na",	NULL,	{ L"i",	L"" } },		{ L"ne",	NULL,	{ L"l",	L"" } },
	{ L"ni",	NULL,	{ L"j",	L"" } },		{ L"nn",	NULL,	{ L"",	L"" } },
	{ L"no",	NULL,	{ L"m",	L"" } },		{ L"nu",	NULL,	{ L"k",	L"" } },
	{ L"nya",	NULL,	{ L"j",	L"ɂ" } },	{ L"nye",	NULL,	{ L"jF",	L"ɂ" } },
	{ L"nyi",	NULL,	{ L"jB",	L"ɂ" } },	{ L"nyo",	NULL,	{ L"j",	L"ɂ" } },
	{ L"nyu",	NULL,	{ L"j",	L"ɂ" } },
	{ L"o",		NULL,	{ L"I",	L"" } },
	{ L"pp",	L"p",	{ L"b",	L"" } },		{ L"pa",	NULL,	{ L"p",	L"" } },
	{ L"pe",	NULL,	{ L"y",	L"" } },		{ L"pi",	NULL,	{ L"s",	L"" } },
	{ L"po",	NULL,	{ L"|",	L"" } },		{ L"pu",	NULL,	{ L"v",	L"" } },
	{ L"pya",	NULL,	{ L"s",	L"҂" } },	{ L"pye",	NULL,	{ L"sF",	L"҂" } },
	{ L"pyi",	NULL,	{ L"sB",	L"҂" } },	{ L"pyo",	NULL,	{ L"s",	L"҂" } },
	{ L"pyu",	NULL,	{ L"s",	L"҂" } },
	{ L"rr",	L"r",	{ L"b",	L"" } },		{ L"ra",	NULL,	{ L"",	L"" } },
	{ L"re",	NULL,	{ L"",	L"" } },		{ L"ri",	NULL,	{ L"",	L"" } },
	{ L"ro",	NULL,	{ L"",	L"" } },		{ L"ru",	NULL,	{ L"",	L"" } },
	{ L"rya",	NULL,	{ L"",	L"" } },	{ L"rye",	NULL,	{ L"F",	L"肥" } },
	{ L"ryi",	NULL,	{ L"B",	L"股" } },	{ L"ryo",	NULL,	{ L"",	L"" } },
	{ L"ryu",	NULL,	{ L"",	L"" } },
	{ L"ss",	L"s",	{ L"b",	L"" } },		{ L"sa",	NULL,	{ L"T",	L"" } },
	{ L"se",	NULL,	{ L"Z",	L"" } },		{ L"sha",	NULL,	{ L"V",	L"" } },
	{ L"she",	NULL,	{ L"VF",	L"" } },	{ L"shi",	NULL,	{ L"V",	L"" } },
	{ L"sho",	NULL,	{ L"V",	L"" } },	{ L"shu",	NULL,	{ L"V",	L"" } },
	{ L"si",	NULL,	{ L"V",	L"" } },		{ L"so",	NULL,	{ L"\",	L"" } },
	{ L"su",	NULL,	{ L"X",	L"" } },		{ L"sya",	NULL,	{ L"V",	L"" } },
	{ L"sye",	NULL,	{ L"VF",	L"" } },	{ L"syi",	NULL,	{ L"VB",	L"" } },
	{ L"syo",	NULL,	{ L"V",	L"" } },	{ L"syu",	NULL,	{ L"V",	L"" } },
	{ L"tt",	L"t",	{ L"b",	L"" } },		{ L"ta",	NULL,	{ L"^",	L"" } },
	{ L"te",	NULL,	{ L"e",	L"" } },		{ L"tha",	NULL,	{ L"e@",	L"Ă" } },
	{ L"the",	NULL,	{ L"eF",	L"Ă" } },	{ L"thi",	NULL,	{ L"eB",	L"Ă" } },
	{ L"tho",	NULL,	{ L"e",	L"Ă" } },	{ L"thu",	NULL,	{ L"e",	L"Ă" } },
	{ L"ti",	NULL,	{ L"`",	L"" } },		{ L"to",	NULL,	{ L"g",	L"" } },
	{ L"tsu",	NULL,	{ L"c",	L"" } },		{ L"tu",	NULL,	{ L"c",	L"" } },
	{ L"tya",	NULL,	{ L"`",	L"" } },	{ L"tye",	NULL,	{ L"`F",	L"" } },
	{ L"tyi",	NULL,	{ L"`B",	L"" } },	{ L"tyo",	NULL,	{ L"`",	L"" } },
	{ L"tyu",	NULL,	{ L"`",	L"" } },
	{ L"u",		NULL,	{ L"E",	L"" } },
	{ L"vv",	L"v",	{ L"b",	L"" } },		{ L"va",	NULL,	{ L"@",	L"J" } },
	{ L"ve",	NULL,	{ L"F",	L"J" } },	{ L"vi",	NULL,	{ L"B",	L"J" } },
	{ L"vo",	NULL,	{ L"H",	L"J" } },	{ L"vu",	NULL,	{ L"",	L"J" } },
	{ L"ww",	L"w",	{ L"b",	L"" } },		{ L"wa",	NULL,	{ L"",	L"" } },
	{ L"we",	NULL,	{ L"EF",	L"" } },	{ L"wi",	NULL,	{ L"EB",	L"" } },
	{ L"wo",	NULL,	{ L"",	L"" } },		{ L"wu",	NULL,	{ L"E",	L"" } },
	{ L"xx",	L"x",	{ L"b",	L"" } },		{ L"xa",	NULL,	{ L"@",	L"" } },
	{ L"xe",	NULL,	{ L"F",	L"" } },		{ L"xi",	NULL,	{ L"B",	L"" } },
	{ L"xka",	NULL,	{ L"",	L"" } },		{ L"xke",	NULL,	{ L"",	L"" } },
	{ L"xo",	NULL,	{ L"H",	L"" } },		{ L"xtsu",	NULL,	{ L"b",	L"" } },
	{ L"xtu",	NULL,	{ L"b",	L"" } },		{ L"xu",	NULL,	{ L"D",	L"" } },
	{ L"xwa",	NULL,	{ L"",	L"" } },		{ L"xwe",	NULL,	{ L"",	L"" } },
	{ L"xwi",	NULL,	{ L"",	L"" } },		{ L"xya",	NULL,	{ L"",	L"" } },
	{ L"xyo",	NULL,	{ L"",	L"" } },		{ L"xyu",	NULL,	{ L"",	L"" } },
	{ L"yy",	L"y",	{ L"b",	L"" } },		{ L"ya",	NULL,	{ L"",	L"" } },
	{ L"ye",	NULL,	{ L"CF",	L"" } },	{ L"yo",	NULL,	{ L"",	L"" } },
	{ L"yu",	NULL,	{ L"",	L"" } },
	{ L"zz",	L"z",	{ L"b",	L"" } },		{ L"za",	NULL,	{ L"U",	L"" } },
	{ L"ze",	NULL,	{ L"[",	L"" } },		{ L"zi",	NULL,	{ L"W",	L"" } },
	{ L"zo",	NULL,	{ L"]",	L"" } },		{ L"zu",	NULL,	{ L"Y",	L"" } },
	{ L"zya",	NULL,	{ L"W",	L"" } },	{ L"zye",	NULL,	{ L"WF",	L"" } },
	{ L"zyi",	NULL,	{ L"WB",	L"" } },	{ L"zyo",	NULL,	{ L"W",	L"" } },
	{ L"zyu",	NULL,	{ L"W",	L"" } },
} ;

static struct TSkkBaseRuleT2	_rT2 []	= {
	{ L"z,",	NULL,	L"d" },	{ L"z-",	NULL,	L"`" },    { L"z.",	NULL,	L"c" },
	{ L"z/",	NULL,	L"E" },    { L"z[",	NULL,	L"w" },    { L"z]",	NULL,	L"x" },
    { L"zh",	NULL,	L"" },    { L"zj",	NULL,	L"" },    { L"zk",	NULL,	L"" },
	{ L"zl",	NULL,	L"" },    { L"-",		NULL,	L"[" },    { L":",		NULL,	L"F" },
    { L";",		NULL,	L"G" },    { L"?",		NULL,	L"H" },    { L"[",		NULL,	L"u" },
	{ L"]",		NULL,	L"v" },
} ;

static struct TSkkBaseRuleT3	_rT3 []	= {
	{ L".",		NULL,	NFUNC_SKK_CURRENT_KUTEN },			{ L",",		NULL,	NFUNC_SKK_CURRENT_TOUTEN },
	{ L"l",		NULL,	NFUNC_SKK_LATIN_MODE },				{ L"q",		NULL,	NFUNC_SKK_TOGGLE_KANA },
	{ L"L",		NULL,	NFUNC_SKK_JISX0208_LATIN_MODE },	{ L"Q",		NULL,	NFUNC_SKK_SET_HENKAN_POINT_SUBR },
	{ L"X",		NULL,	NFUNC_SKK_PURGE_FROM_JISYO },		{ L"/",		NULL,	NFUNC_SKK_ABBREV_MODE },
	{ L"$",		NULL,	NFUNC_SKK_DISPLAY_CODE_FOR_CHAR_AT_POINT },
	{ L"@",		NULL,	NFUNC_SKK_TODAY },					{ L"\\",	NULL,	NFUNC_SKK_INPUT_BY_CODE_OR_MENU },
	{ L"\r",	NULL,	NFUNC_SKK_KAKUTEI },
} ;

BOOL
imeConfig_bInitializeDefaultRomaKanaRuleTree (
	CSkkRuleTreeNode**			ppTree)
{
	CSkkRuleTreeNode*	pRoot ;
	int		i, nPrefix, nNextState ;

	if (ppTree == NULL)
		return	FALSE ;

	pRoot	= NULL ;
	for (i = 0 ; i < MYARRAYSIZE (_rT1) ; i ++) {
		int	nHira, nKata ;

		nPrefix		= (_rT1 [i]._strState      != NULL)? lstrlenW (_rT1 [i]._strState)      : 0 ;
		nNextState	= (_rT1 [i]._strNext       != NULL)? lstrlenW (_rT1 [i]._strNext)       : 0 ;
		nHira		= (_rT1 [i]._case._strHira != NULL)? lstrlenW (_rT1 [i]._case._strHira) : 0 ;
		nKata		= (_rT1 [i]._case._strKata != NULL)? lstrlenW (_rT1 [i]._case._strKata) : 0 ;
		if (! CSkkRuleTreeNode::bAddRule (&pRoot, _rT1 [i]._strState, nPrefix, _rT1 [i]._strNext, nNextState, _rT1 [i]._case._strHira, nHira, _rT1 [i]._case._strKata, nKata)) {
			CSkkRuleTreeNode::vDestroyTree (pRoot) ;
			return	FALSE ;
		}
	}
	for (i = 0 ; i < MYARRAYSIZE (_rT2) ; i ++) {
		int	nOutput ;
		nPrefix		= (_rT2 [i]._strState  != NULL)? lstrlenW (_rT2 [i]._strState)  : 0 ;
		nNextState	= (_rT2 [i]._strNext   != NULL)? lstrlenW (_rT2 [i]._strNext)   : 0 ;
		nOutput		= (_rT2 [i]._strOutput != NULL)? lstrlenW (_rT2 [i]._strOutput) : 0 ;
		if (! CSkkRuleTreeNode::bAddRule (&pRoot, _rT2 [i]._strState, nPrefix, _rT2 [i]._strNext, nNextState, _rT2 [i]._strOutput, nOutput)) {
			CSkkRuleTreeNode::vDestroyTree (pRoot) ;
			return	FALSE ;
		}
	}
	for (i = 0 ; i < MYARRAYSIZE (_rT3) ; i ++) {
		nPrefix		= (_rT3 [i]._strState  != NULL)? lstrlenW (_rT3 [i]._strState)  : 0 ;
		nNextState	= (_rT3 [i]._strNext   != NULL)? lstrlenW (_rT3 [i]._strNext)   : 0 ;
		if (! CSkkRuleTreeNode::bAddRule (&pRoot, _rT3 [i]._strState, nPrefix, _rT3 [i]._strNext, nNextState, _rT3 [i]._nFunction)) {
			CSkkRuleTreeNode::vDestroyTree (pRoot) ;
			return	FALSE ;
		}
	}
	*ppTree	= pRoot ;
	return	TRUE ;
}
