/*	editsink.cpp
 *
 *	ITfTextEditSink implementation
 */
#include "globals.h"
#include "skimic.h"

/*	OnEndEdit
 *
 *	Called by the system whenever anyone releases a write-access document lock.
 *	N write-access hLg̃bNɏɃVXeɂ
 *	ĂяoB
 *(*)
 *	 write-access document lock Ă̂́Aǂ󋵂̂ƂŁA
 *	ꂪ release Ƃ̂́AǂƁH
 *(*)
 *	Case Ŋώ@Ă݂̂Aۂ Lock/Unlock ^C~O͗ǂ
 *	ȂBCase ɂ́u[hvȂ(͒AϊAȂāA
 *	m)̂ŁAKeyDown -> OnEndEdit ƂȂ̂낤B
 *
 *	AOnEndEdit Ă΂錴 KeyDown ̒ɂ̂H ̂
 *	łBm OnKeyDown  SYNC OɁALock/Release ݂
 *	ƎvcAꂪŔĂ̂ȂALock/Release ͂Ɓc
 *	Focus/Unfocus um葀v̈ʒuɓȂƂȂȂȁcB
 *
 *	܂܂ȂƂȂAĂŉȂƂȂ̂
 *	lȂ΁B
 */
STDAPI
CSkkImeTextService::OnEndEdit (
	ITfContext*		pContext,
	TfEditCookie	ecReadOnly,
	ITfEditRecord*	pEditRecord)
{
	/*	CaseTextService ł SnoopWindow Ƃ̂ɁA
	 *	umv\AƂsĂB
	 */
    return	S_OK ;
}

/*	_InitTextEditSink
 *
 *	hLg̍ŏʃReLXg text edit sink B
 *	ɈȑO sink ͉B
 *(*)
 *	[ށACɂȂȂȁcB
 *	Ȃ͊mɕKvȋCB Case Text Service 
 *	ŗL̏Ă悤ɂ(ƌ)ȂB
 */
BOOL
CSkkImeTextService::_InitTextEditSink (
	ITfDocumentMgr*		pDocMgr)
{
    ITfSource*	pSource ;
    BOOL		fRet ;
	
	/*	O Sink ܂ŏɒ@B
	 */
    if (_dwTextEditSinkCookie != TF_INVALID_COOKIE) {
        if (_pTextEditSinkContext->QueryInterface (IID_ITfSource, (void **)&pSource) == S_OK) {
            pSource->UnadviseSink (_dwTextEditSinkCookie) ;
            pSource->Release () ;
        }
        _pTextEditSinkContext->Release () ;
        _pTextEditSinkContext	= NULL ;
        _dwTextEditSinkCookie	= TF_INVALID_COOKIE ;
    }

    if (pDocMgr == NULL)
        return	TRUE ;	// caller just wanted to clear the previous sink

    // setup a new sink advised to the topmost context of the document
    if (pDocMgr->GetTop(&_pTextEditSinkContext) != S_OK)
        return	FALSE ;

    if (_pTextEditSinkContext == NULL)
        return	TRUE ;	// empty document, no sink possible

    fRet = FALSE;

    if (_pTextEditSinkContext->QueryInterface (IID_ITfSource, (void **)&pSource) == S_OK) {
        if (pSource->AdviseSink(IID_ITfTextEditSink, (ITfTextEditSink *)this, &_dwTextEditSinkCookie) == S_OK) {
            fRet	= TRUE ;
        } else {
            _dwTextEditSinkCookie	= TF_INVALID_COOKIE ;
        }
        pSource->Release () ;
    }
    if (fRet == FALSE) {
        _pTextEditSinkContext->Release () ;
        _pTextEditSinkContext	= NULL ;
    }
    return	fRet ;
}
